BEGIN;



CREATE SEQUENCE mismenu_id_seq;

CREATE TABLE mismenu (
  id INT4 DEFAULT nextval('mismenu_id_seq'),
  parentid INT4 NOT NULL DEFAULT '0',
  sortorder INT4 NOT NULL DEFAULT '0',
  name varchar(64) NOT NULL DEFAULT '',
  moduleid INT4 NOT NULL DEFAULT '0',
  basedir varchar(80) NOT NULL DEFAULT '',
  phpfile varchar(80) NOT NULL DEFAULT '',
  action varchar(80) NOT NULL DEFAULT '',
  imagefile varchar(128) NOT NULL DEFAULT '',
  type INT4 NOT NULL DEFAULT '0',
  PRIMARY KEY (id)
);

CREATE SEQUENCE mismenuauth_id_seq;

CREATE TABLE mismenuauth (
  id INT4 DEFAULT nextval('mismenuauth_id_seq'),
  menuid INT4 NOT NULL DEFAULT '0',
  interfaceid INT4 NOT NULL DEFAULT '0',
  PRIMARY KEY (id)
);

CREATE SEQUENCE mismodule_id_seq;

CREATE TABLE mismodule (
  id INT4 DEFAULT nextval('mismodule_id_seq'),
  moduleid INT4 NOT NULL DEFAULT '0',
  version varchar(12) NOT NULL DEFAULT '"00.00.00.00',
  name varchar(80) NOT NULL DEFAULT '',
  title varchar(255) NOT NULL DEFAULT '',
  author varchar(255) NOT NULL DEFAULT '',
  cmid INT4 NOT NULL DEFAULT '0',
  description varchar(255) NOT NULL DEFAULT '',
  enabled char(1) NOT NULL DEFAULT 'N',
  CHECK(enabled='N' OR enabled='Y' OR enabled='S'),
  PRIMARY KEY (id)
);

CREATE INDEX MenuID_mismenuauth_index ON mismenuauth (menuid);

COMMIT;
