<?php
/*
bank.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001 - 2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/account.php");
require_once($_SESSION['CFG']->libdir."/address.php");
require_once($_SESSION['CFG']->libdir."/contact.php");

if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
else{
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   $frm['action']=$_REQUEST['action'];
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], bank_pagetitle)!=0){
   $_SESSION['title']=bank_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(bank_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_REQUEST['action']!="contactadd"){
   if($_SESSION['CFG']->onlinehelp){
      include($_SESSION['CFG']->templatedir."/phheader.php");
   }
   else{
      include($_SESSION['CFG']->templatedir."/pheader.php");
   }
}

switch($_REQUEST['action']){
	case "clear":
		addBank();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseBank($id);
		break;

	case "edit" :
		editBank($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelBank($_REQUEST['id']);
      }
      else{
         deleteBank($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listBank();
      }
      break;  
	
   case "cfmdelete" :
      deleteBank($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listBank();
		break;
      
	case "add" :
		insertBank($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitBank($_POST);
      listBank();
		break;

   case "find":
      searchBank($_POST);
      break;
      
	case "list":
	default :
      $id=updateNav($_POST);
		listBank();
		break;
      
   case "contactadd" :
		contactAdd($id, $cid);
		break;
      
   case "contacthide" :
		contactHide($_REQUEST['id']);
		break;
      
   case "contactedit" :
		contactEdit($_REQUEST['id']);
		break;

	case "contactcommit" :
		contactCommit($_POST);
		break;

	case "details" :
		bankStatus();
		break;

	case "receipts":
		bankReceipts();
		break;
		
	case "payments":
		bankPayments();
		break;
		
	case "transfer":
		bankTrans();
		break;
   
   case "transaction":
		bankTransaction();
		break;
		
	case "reconcile":
		bankReconcile();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(bank_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "";
   $frm["bankid"] = "";
   $frm["accountid"] = "";
   $frm["name"] = "";
   $frm["branch"] = "";
   $frm["addressid"] = "";
   $frm["accountid"] = "";
   $frm["contactid"] = "";
   $frm["banksortcode"] = "";
   $frm["banknumber"] = "";

	return $frm;
}
function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(bank_qry2, $id);
   }
   else{
      $qry=sprintf(bank_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"] = $id;
	$frm["bankid"] = $row["bankid"];
   $frm["accountid"] = $row["accountid"];
   $frm["name"] = $row["name"];
   $frm["branch"] = $row["branch"];
   $frm["addressid"] = $row["addressid"];
	$frm["accountid"] = $row["accountid"];
   $frm["contactid"] = $row["contactid"];
   $frm["banksortcode"] = $row["banksortcode"];
   $frm["banknumber"] = $row["banknumber"];

	return $frm;
}

function addBank()
{
   $frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = bank_admin_add;

	include("templates/bankedit.php");
}

function editBank($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = bank_admin_edit;
	
	include("templates/bankedit.php");
}

function browseBank($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = bank_admin_browse;
	
	include("templates/bankedit.php");
}

function chkdelbank($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["heading"] = bank_admin_delete;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/bankedit.php");
}

function deleteBank($id) 
{
   $qry=sprintf(bank_qry7, $id);
   db_query($qry);
}

function insertBank($frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
   $adid=$a->Add();
   
   $qry=sprintf(bank_qry4, 0, $frm['accountid'], $frm['name'], $frm['branch'], $adid,
      0, $frm['banksortcode'], $frm['banknumber']);
   
	db_query($qry);
   
   $frm["newaction"] = "contactadd";
   $frm["heading"] = "Bank Contact Add";
	
	include("templates/bankedit.php");
}

function commitBank($frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
   $aid=$frm['addressid'];
   $a->Commit($aid);
   $qry=sprintf(bank_qry5, $frm['name'], $frm['branch'], $frm['addressid'],
	   $frm['accountid'], $frm['contactid'], $frm['banksortcode'],	$frm['banknumber'],$frm['id']);
	         
   db_query($qry);
}

function searchBank($frm)
{
   $b=new BankDetails();
   if($b){
      $b->FillFromForm($frm);
      $b->Find(true);
   }
}

function contactAdd($tid, $cid)
{
   $c=new ContactList();
   $c->Add($cid, "bankdetails", $tid);
}

function contactHide($id)
{
   $frm=fillForm($id);
   
	$frm["newaction"] = "commit";
   $frm["heading"] = "Bank Edit";
	
	include("templates/bankedit.php");
}

function contactEdit($id)
{
   $frm=fillForm($id);
   
	$frm["newaction"] = "contactcommit";
   $frm["heading"] = "Bank Contact Edit";
	
	include("templates/bankedit.php");
}

function contactCommit($frm)
{
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "Address");
}

function AccountCombo($action, $id)
{
   $a=new Account();
   $a->Combo($action, $id, "accountid");
}

function fillContact($a, $cid, $id)
{
   $ref=$_SERVER['PHP_SELF']."?action=contactedit&id=".$id;
   
   //$ref=$_SERVER['PHP_SELF']."?action=contacthide";
   
   $c=new ContactList();
   $c->fill($cid);
   $c->Table($a, $cid, $ref, "bankdetails", $id, $_SERVER['PHP_SELF']);
}

function listBank()
{
	$q=$_SESSION["pageindex"]->query(bank_qry6);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
	echo "<table class=\"list\">\n";
	echo "<tr><td class=\"listtitle\">".bank_admin_listname."</td><td class=\"listtitle\">".misc_listheadaction."</td></tr>";
	while($myrow = $result->FetchRow()){
		print "<tr><td>";
		if($myrow["name"]){
		   $n=$myrow["name"];
			echo "$n";
		}
		else{
		   echo "No Name";
		}
		print "</td><td>";
		$wibbler=$myrow["id"];
		print "<a href=\"bank.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"bank.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"bank.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

function bankStatus()
{
	echo "<br><br><center><h3>Not been implemented yet.</h3></center>";
   exit;
}

function bankReceipts()
{
	echo "<br><br><center><h3>Not been implemented yet.</h3></center>";
   exit;
}

function bankPayments()
{
	echo "<br><br><center><h3>Not been implemented yet.</h3></center>";
   exit;
}

function bankTransfer()
{
	echo "<br><br><center><h3>Not been implemented yet.</h3></center>";
   exit;
}

function bankTransaction()
{
}

function bankReconcile()
{
}
?>
