<?php
/*
banktrans.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/account.php");
require_once($_SESSION['CFG']->libdir."/bank.php");
require_once($_SESSION['CFG']->libdir."/transaction.php");
require_once($_SESSION['CFG']->libdir."/timedate.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}
if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], bank_pagetitle)!=0){
   $_SESSION['title']=bank_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(banktrans_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addBank();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseBank($id);
		break;

	case "edit" :
		editBank($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelBank($_REQUEST['id']);
      }
      else{
         deleteBank($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listBank($_POST['id']);
      }
      break;
      
   case "cfmdelete" :
      deleteBank($_POST);
      $id=$_SESSION["pageindex"]->deletion(CountNum());
      listBank($id);
		break;

	case "add" :
		insertBank($_POST);
      $id=$_SESSION["pageindex"]->addition(CountNum());
      listBank($id);
		break;

	case "commit" :
		commitBank($_POST['id'], $_POST);
      listBank($_POST['id']);
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listBank($id);
		break;
   
   case "reconcile":
		bankReconcile();
		break;
      
   case "recommit":
		bankRecCommit(_POST);
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(banktrans_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "";
   $frm["bankid"] = "";
   $frm["itemdate"] = "";
   $frm["itemtype"] = "";
   $frm["accountid"] = "";
   $frm["transid"] = "";
   $frm["referencedata"] = "";
   $frm["amount"] = "";
   $frm["gentrans"] = 'N';
   
	return $frm;
}
function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(banktrans_qry2, $id);
   }
   else{
      $qry=sprintf(banktrans_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["id"] = $id;
   $frm["bankid"] = $row["bankid"];
   $frm["itemdate"] = $row["itemdate"];
   $frm["itemtype"] = $row["itemtype"];
   $frm["accountid"] = $row["accountid"];
   $frm["transid"] = $row["transid"];
   $frm["referencedata"] = $row["referencedata"];
   $frm["amount"] = sprintf("%0.2f", $row["amount"]);
   $frm["gentrans"] = 'N';
	return $frm;
}

function addBank()
{
   $frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = bank_trans_add;

	include("templates/banktrans.php");
}

function editBank($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = bank_trans_edit;
	
	include("templates/banktrans.php");
}

function browseBank($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] =  bank_trans_browse;
	
	include("templates/banktrans.php");
}

function chkdelbank($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["heading"] =  bank_trans_delete;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/banktrans.php");
}

function deleteBank($frm) 
{
   if($frm['gentrans']=='Y'){
      $qry=sprintf(banktrans_qry11, $frm['transid']);
      db_query($qry);
   }
   $qry=sprintf(banktrans_qry10, $frm['id']);
   db_query($qry);
}

function insertBank($frm) 
{
   $idate=$frm['year']."-".$frm['month']."-".$frm['day'];
   if($frm['gentrans']=='N'){
      $qry=sprintf(banktrans_qry9, $frm['bankid'],$idate,$frm['itemtype'],
         $frm['accountid'],0,$frm['referencedata'],$frm['amount']);
   }
   else{
      $t=new Transaction();
      $td=new TimeDate();
      $result=db_query(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
      $ts=$td->ansidate();
      $t->Set($ts,
         $_SESSION['misuser']->GetEmployee(),
         $_SESSION['misuser']->GetFullStation(),
         0,0,'','Bank','N','N','Y',0,0);
      $tid=$t->Add();

      $qry=sprintf(banktrans_qry9, $frm['bankid'],$idate,$frm['itemtype'],
         $frm['accountid'],$tid,$frm['referencedata'],$frm['amount']);
   }
   db_query($qry);
}

function commitBank($id, $frm) 
{
   $idate=$frm['year']."-".$frm['month']."-".$frm['day'];
   // needs $frm['transid']
   $qry=sprintf(banktrans_qry4,$frm['bankid'],$idate,$frm['itemtype'],$frm['accountid'],0,$frm['referencedata'],
      $frm['amount'], $id);
   db_query($qry);
}

function fillAccountCombo($a, $id) 
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function fillBankCombo($action, $id)
{
   $b=new BankDetails();
   $b->Combo($action, $id, "bankid");
}

function fillBankTypeCombo($a, $id)
{
   if($a=="commit" || $a=="add"){
      $result=db_query("SELECT * FROM bankitemtype");
      echo "<select name=\"itemtype\" width=\"250\">\n";
   	while($row = $result->FetchRow()){
	   	$boo=$row["id"];
		   $poo=$row["name"];
   		if($id==$boo){
	   		print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
	   echo "</select>\n";
   }
   else{
      
      if($id != NULL){
         $result=db_query("SELECT name FROM bankitemtype WHERE id='$id'");
         $row = $result->FetchRow();
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}

function DateControl($a, $d)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
	   $result=db_query(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->datecontrol($a, "");
}

function listBank($id)
{
   $q=banktrans_qry5;
	$q=$_SESSION["pageindex"]->query($q);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
   $td=new TimeDate();

	echo "<br><br>";
	echo "<table class=\"list\">\n";
	echo "<tr><td class=\"listtitle\">Name</td><td class=\"listtitle\">Ref</td><td class=\"listtitle\">Date</td>";
   echo "<td class=\"listtitle\">Type</td><td class=\"listtitle\">Amount</td><td class=\"listtitle\">Action</td></tr>";
	while($row = $result->FetchRow()){
      $qry=sprintf(banktrans_qry6, $row['bankid']);
      $nresult=db_query($qry);
      if($nrow = $nresult->FetchRow()){
         echo "<tr><td>$nrow[0]</td>";
      }
      else{
         echo "<tr><td>Not Set</td>";
      }
		if($row["referencedata"]){
		   $n=$row["referencedata"];
			echo "<td>$n</td>";
		}
		else{
		   echo "<td>-</td>";
		}
      if($row["itemdate"]){
         echo "<td>";
         $td->parse($row['itemdate']);
         $td->datecontrol("browse", "");
         echo "</td>\n";
		}
		else{
		   echo "<td>-</td>";
		}
      $qry2=sprintf(banktrans_qry7, $row['itemtype']);
      $tresult=db_query($qry2);
      if($trow = $tresult->FetchRow()){
         echo "<td>$trow[0]</td>";
      }
      else{
         echo "<td>-</td>";
      }
      $a=sprintf("%0.2f", $row['amount']);
      echo "<td>$a</td><td>";
      
		$wibbler=$row["id"];
		echo "<a href=\"banktrans.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		echo "<a href=\"banktrans.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		echo "<a href=\"banktrans.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

function bankReconcile()
{
	$q=$_SESSION["pageindex"]->query(banktrans_qry8);
	$result=db_query($q);
   
   if(db_num_rows($result)==0){
      echo "<br><br>There are no outstanding bank items";
      return;
   }
   $_REQUEST['action']="list";
   
   $td=new TimeDate();

	echo "<br><br>";
   echo "<form name=\"bankrec\" method=\"post\" action=\"" . $_SERVER['PHP_SELF'] . "\">";
   echo "<input type=\"hidden\" name=\"action\" value=\"reccommit\">";
	echo "<table class=\"list\">\n";
	echo "<tr><td class=\"listtitle\">Bank</td><td class=\"listtitle\">Date</td><td class=\"listtitle\">Type</td>";
   echo "<td class=\"listtitle\">Ref</td><td class=\"listtitle\">Amount</td><td class=\"listtitle\">Close</td></tr>";
	while($row = $result->FetchRow()){
      $qry=sprintf(banktrans_qry6, $row['bankid']);
      $nresult=db_query($qry);
      if($nrow = $nresult->FetchRow()){
         $bankname=$nrow['name'];
         echo "<tr><td>$bankname</td>";
      }
      else{
         echo "<tr><td>Not Set</td>";
      }
      if($row["itemdate"]){
         echo "<td>";
         $td->parse($row['itemdate']);
         $td->datecontrol("browse", "");
         echo "</td>\n";
		}
		else{
		   echo "<td>-</td>";
		}
      $qry2=sprintf(banktrans_qry7, $row['itemtype']);
      $zresult=db_query($qry2);
      if($zrow = $zresult->FetchRow()){
         $typename=$zrow['name'];
         echo "<td>$typename</td>";
      }
      else{
         echo "<td>Not Set</td>";
      }
      $a=sprintf("%0.2f", $row['amount']);
      echo "<td>$row[2]</td><td>$a</td>";
		$wibbler=$row["id"];
		
		echo "<td><input type=\"checkbox\" name=\"$wibbler\"></td></tr>\n";
	}
	echo "</table><br>";
   echo "<input type=\"submit\" name=\"Commit\">";
	echo "</form><br>";
}

function bankRecCommit($frm)
{
   // id
   show_post_vars();
}

?>
