<?php

class menu {
  var $name;
  var $varname;
  var $directory = false;
  var $image = false;

  function menu($menu_name, $menu_args = false, $dir = false) 
  {
    global $_menu_id;
    global $_no_javascript;

    $this->name = $menu_name;
    $this->varname = str_replace(' ', '_', strtolower($menu_name));
    if ($_menu_id++ != 0)
      $this->varname .= $_menu_id;
    $this->directory = $dir;
    if (is_array($menu_args) && count($menu_args) > 1)
      if (isset($menu_args[1]) && $menu_args[1] != '')
	 $this->image = $menu_args[1];
    if (!$_no_javascript) {
      echo "var $this->varname = null;\n";
      echo "$this->varname = new MTMenu();\n\n";
    }
  }

  function add_menu($submenu)
  {
    global $_no_javascript;
    if ($_no_javascript)
      echo "<li>$submenu->name<ul>\n";
    else
      echo "$this->varname.addItem('$submenu->name');\n";
  }

  function add($item_name, $args)
  {
    global $_no_javascript;
    $php_name = false;
    $action = false;

    if (is_array($args) && count($args) > 1)
    {
      $php_name = $args[1];
      if (count($args) > 2)
	$action = $args[2];
    }
    if (preg_match('/[\.\?]/', $php_name))
      $url=$php_name;
    else {
      $url = "$this->directory/$php_name.php";
      if ($action)
	$url .= "?action=$action";
    }
    if ($_no_javascript)
      echo "<li><a href='$url' target='main'>$item_name</a></li>\n";
    else {
      echo "$this->varname.addItem('$item_name','$url','main'";
      if (count($args) > 3)	// we have an image to add
      {
	$image = $args[3];
	$short_name = str_replace(' ', '_', strtolower($item_name));
	echo ",'$short_name','$image'";
      }
      echo ");\n";
    }
  }

  function submenu($submenu)
  {
    global $_no_javascript;

    if ($_no_javascript) {
      echo "</ul>\n";
    } else {
      echo "$this->varname.makeLastSubmenu($submenu->varname, false";
      if ($submenu->image)
	echo ", '$submenu->image', '$submenu->image'";
      echo ");\n\n";
    }
  }
};


// Find the script for each menu - based upon the base-level menu list
function process_menulist($dir)
{
  global $menu_stack;

  // If a menu.js file exists, incorporate verbatim.  Allows for
  // an easy transition to the menulist method
  $menujs = realpath("$dir/menu.js");
  if ($menujs) {
    $fd = fopen($menujs, "r");
    if ($fd) {
      fpassthru($fd);
    }
  }
  $menulist = realpath("$dir/menulist");
  if($menulist){
    $fd = fopen($menulist, "r");
    if($fd){
      $current_menu =& $menu_stack[0];
      $menu_depth = count($menu_stack);
      while(!feof($fd)){
	      $menuitem = fgets($fd, 1024);
         if(!$menuitem)	// the !feof doesn't work as advertised!!
	         break;
	      $menuargs = explode(',', rtrim($menuitem));
         $menustyle = substr($menuargs[0], 0, 1);
	      switch (substr($menuargs[0], 0, 1)) {
	      case '>':	// New submenu of this menu
   	      $submenu =& new menu(substr($menuargs[0], 1), $menuargs, $dir);
	         $current_menu->add_menu($submenu);
	         array_unshift($menu_stack, $submenu);
   	      $current_menu =& $submenu;
	         break;
	      case '<':	// unindent - return from nested submenu
	         $submenu =& array_shift($menu_stack);
	         $current_menu =& $menu_stack[0];
   	      $current_menu->submenu($submenu);
	         break;
	      case '*':	// Default style submenu
	         $submenu =& new menu(substr($menuargs[0], 1), $menuargs, $dir);
   	      $current_menu->add_menu($submenu);
	         $submenu->add('Browse', array('', $menuargs[2], 'browse'));
	         $submenu->add('List', array('', $menuargs[2], 'list'));
	         $submenu->add('Add', array('', $menuargs[2], 'clear'));
	         $current_menu->submenu($submenu);
	         break;
	      case '!':	// Action.
	         $action = substr($menuargs[0], 1);
	         $current_menu->add($action, $menuargs);
	         break;
	      case '+':	// Subdirectory - recurse.
	         $subdir = substr($menuargs[0], 1);
	         process_menulist("$dir/" . $subdir);
	         break;
	      case '#':	// Commented out menu item
	         break;
	      default :	// Menu heading, starts a new menu that gets added
	         $current_menu =& new menu($menuargs[0], $menuargs, $dir);
            $menu_stack[0]->add_menu($current_menu);
	         array_unshift($menu_stack, $current_menu);
	         break;
	      }
      }
      while ($menu_depth < count($menu_stack)) {
	      $submenu =& array_shift($menu_stack);
	      $current_menu =& $menu_stack[0];
	      $current_menu->submenu($submenu);
      }
      fclose($fd);
    }
  }
}

$_menu_id = 0;
if (! isset($_no_javascript))
  $_no_javascript = false;
$menu_stack = array();
$current_menu =& new menu('Menu');
array_unshift($menu_stack, $current_menu);
process_menulist(".");
?>
