<?php
/*
group.php

Copyright (C)2002 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001 - 2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/locale.php");
require_once($_SESSION['CFG']->libdir."/currency.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], company_group_pagetitle)!=0){
   $_SESSION['title']=company_group_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(group_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addGroup();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseGroup($id);
		break;

	case "edit" :
		editGroup($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelGroup($_REQUEST['id']);
      }
      else{
         deleteGroup($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listGroup();
      }
		break;

	case "cfmdelete" :
		deleteGroup($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
		listGroup();
		break;

	case "add" :
		insertGroup($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listGroup();
		break;

	case "commit" :
		commitGroup($id, $_POST);
		listGroup();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listGroup();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(group_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{  
	$frm["id"] = 0;
	$frm["groupid"] = "";
	$frm["name"] = "";
	$frm["deptid"] = "";
	$frm["currencyid"]="";
	$frm["localeid"]="";
	$frm["active"]="";
   $frm["numstations"]="0";
   $frm["numemployees"]="0";

	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(group_qry2, $id);
   }
   else{
      $qry=sprintf(group_qry3, $id);
   }
   
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
	$frm["groupid"] = $row["groupid"];
	$frm["name"] = $row["name"];
	$frm["deptid"] = $row["deptid"];
	$frm["currencyid"]=$row["currencyid"];
	$frm["localeid"]=$row["localeid"];
	$frm["active"]=$row["active"];
   
   $qry=sprintf(group_qry7, $id);
   $result=db_query($qry);
   $frm["numstations"]=db_num_rows($result);
   $qry=sprintf(group_qry8, $id);
   $result=db_query($qry);
   $frm["numemployees"]=db_num_rows($result);

	return $frm;
}

function addGroup()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "Group Add";
		
	include("templates/groupedit.php");
}

function editGroup($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Group Edit";

	include("templates/groupedit.php");
}

function browseGroup($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Group Browse";

	include("templates/groupedit.php");
}

function fillassignedstations($id)
{
	$qry=sprintf(group_qry9, $id);
   $result=db_query($qry);
	if(db_num_rows($result)==0){
   	echo "<tr><td colspan=\"2\">No Dependant Stations</td></tr>";
	}
   else{
      while($row = $result->FetchRow()){
   		$name=$row["name"];
   		$sid=$row["id"];
   		echo "<tr><td colspan=\"2\"><a href=\"../station/station.php?action=edit&id=$sid\">$name</a></td></tr>";
   	}
   }
}

function fillassignedusers($id)
{
	$qry=sprintf(group_qry10, $id);
   $result=db_query($qry);
	if((db_num_rows($result))==0){
   	echo "<tr><td colspan=\"2\">No Dependant Users</td></tr>";
   }
   else{
      while($row = $result->FetchRow()){
   		$fname=$row["fname"];
   		$lname=$row["lname"];
   		$eid=$row["id"];
   		echo "<tr><td colspan=\"2\"><a href=\"../users/users.php?action=edit&id=$eid\">$fname $lname</a></td></tr>";
   	}
   }
}

function chkdelGroup($id)
{
   $frm=fillForm($id, false);
   
   $frm["reassignstation"]='0';
   $frm["reassignuser"]='0';
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Group Delete";
   
	include("templates/groupdel.php");
}

function deleteGroup($frm) 
{
	if($frm["reassignstation"]=="1"){
      $qry=sprintf(group_qry10, $frm["groupid"], $frm['id']);
		$qid = db_query($qry);
	}
	else{
		//$qid = db_query("UPDATE posts SET deptID = '0' WHERE groupID = '$frm[ID]'");	
	}
   if($frm["reassignuser"]=="1"){
		$qry=sprintf(group_qry11, $frm["groupid"], $frm['id']);
		$qid = db_query($qry);
	}
	else{
		//$qid = db_query("UPDATE employee SET ggroupID = '0' WHERE groupID = '$frm[ID]']");	
	}

	$qry=sprintf(group_qry12, $frm['id']);
   db_query($qry);

}

function insertGroup($frm) 
{
   $qry=sprintf(group_qry13,$frm['name'],$frm['deptid'],$frm['localeid'],$frm['currencyid'],$frm['active']);
   db_query($qry);
}

function commitGroup($id, $frm) 
{
	$qry=sprintf(group_qry13,$frm['name'],$frm['deptid'],$frm['localeid'],$frm['currencyid'],$frm['active'],$frm['id']);
   db_query($qry);
}
/*
function loadGroup()
{
	$result=db_query("SELECT * from groups");

	while($myrow = $result->FetchRow()){
		$dep[]=sprintf("%02d - %s", $myrow["id"], $myrow["name"]);
	}
}
*/
function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "currencyid");
}

function LocaleCombo($action, $id)
{
   $a=new Locale();
   $a->Combo($action, $id, "localeid");
}

function listGroup()
{
	$q=$_SESSION["pageindex"]->query(group_qry6);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td colspan=\"3\" align=\"center\"><h1>Group Maintenance</h1></td>";
	//echo "<td>";
	//fillDeptCombo($did);
	//echo "</td>";
	echo "<tr><td><h3>Group Name</h3></td><td><h3>Department</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
      $qry=sprintf(dept_qry3,$row["deptid"]);
		$dresult=db_query($qry);
		if($drow = $dresult->FetchRow()){
		   $dn=$drow["name"];
      }
      else{
         $dn="&nbsp;";
      }
		$n=$row["name"];
		print "<tr><td>$n</td><td>$dn</td>";
		print "<td>";
		$wibbler=$row["id"];
		print "<a href=\"group.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"group.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"group.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
