<?php
/*
site.php

Copyright (C)2002 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001 - 2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/address.php");
require_once($_SESSION['CFG']->libdir."/locale.php");
require_once($_SESSION['CFG']->libdir."/currency.php");
require_once($_SESSION['CFG']->libdir."/bank.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], bank_pagetitle)!=0){
   $_SESSION['title']=company_site_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(site_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addSite();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseSite($id);
		break;

	case "edit" :
		editSite($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelSite($_REQUEST['id']);
      }
      else{
         deleteBank($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listSite();
      }
		break;

	case "cfmdelete" :
		deleteSite($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listSite();
		break;

	case "add" :
		insertSite($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listSite();
		break;

	case "commit" :
		commitSite($_POST);
		break;

	case "list":
	default :
      updateNav($_POST);
		listSite();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(site_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["newaction"] = "";
	$frm["showdeps"] = "";
	$frm["id"] = 0;
	$frm["name"] = "";
	$frm["addressid"]="";
	$frm["contactid"]="";
	$frm["localeid"]="";
	$frm["currencyid"]="";
	$frm["bankid"]="";
	$frm["annualbudget"] = "0.00";
	$frm["site"]="";
	$frm["encryption"]="";
	$frm["login"]="";
	$frm["password"]="";
	$frm["active"]="Y";
	
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(site_qry2, $id);
   }
   else{
      $qry=sprintf(site_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"] = $id;
	$frm["siteid"]=$row["siteid"];
	$frm["name"] = $row["name"];
	$aid=$frm["addressid"] = $row["addressid"];
	$frm["contactid"] = $row["contactid"];
	$frm["localeid"] = $row["localeid"];
	$bcid=$frm["currencyid"] = $row["currencyid"];
	$frm["bankid"]=$row["bankid"];
	$frm["annualbudget"] = $row["annualbudget"];
	$frm["site"]=$row["site"];
	$frm["encryption"]="Not Set";
	$frm["login"]="Not Authorized";
	$p=strlen($row["password"]);
	$frm["password"]="Not Authorized";
	$frm["active"]=$row["active"];

	return $frm;
}

function addSite()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "Site Add";

	include("templates/siteedit.php");
}

function editSite($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Site Edit";

	include("templates/siteedit.php");
}

function browseSite($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Site Browse";
	
	include("templates/siteedit.php");
}

function filldepts($id)
{
	$result=db_query("SELECT id, name from departments where siteid = '$id'");	
	while($row = $result->FetchRow()){
		$did=$row["id"];
		$name=$row["name"];
		echo "<tr><td colspan=\"2\"><a href=\"dept.php?action=browse&id=$did\">$name</a></td></tr>";
	}
}

function chkdelSite($id)
{
	$result=db_query("select id from departments where siteid = '$id'");
	$frm["numdepts"]=db_num_rows($result);

	$result=db_query("select name from sites where id = '$id'");
	$row = $result->FetchRow();
	$frm["name"]=$row["name"];

   $frm["id"]=$id; 
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Site Delete";
   
	include("templates/sitedel.php");
}

function insertSite($frm) 
{
	$name=$frm["name"];
	$ab=$frm["AnnualBudget"];
	$h=$frm["contactID"];
   
   $a=new Address();
   $a->SetFromForm($frm);
   $adid=$a->Add();
	
   $qry=sprintf(site_qry4,$frm['name'],$adid,$frm['contactid'],$frm['localeid'],$frm['currencyid'], 
		$frm['bankid'],$frm['annualbudget'],$frm['site'],$frm['encryption'],$frm['login'], $frm['password'],
		$frm['active']);
   
	db_query($qry);
}

function commitSite($frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
   $aid=$frm['addressID'];
   $a->Commit($aid);

   $qry=sprintf(site_qry5,$frm['name'],$frm['addressid'],$frm['contactid'],$frm['localeid'],
   $frm['currencyid'],$frm['annualbudget'],$frm['site'],$frm['encryption'],$frm['login'],$frm['password'],
   $frm['active'],$frm['bankid'],$frm['id']);

	db_query($qry);
}

function deleteSite($frm) 
{
	if($frm["reassign"]=="1"){
		$ndept=$frm["departments"];
      $qry=sprintf(site_qry8, $ndept, $frm["ID"]);
		db_query($qry);
	}
	else{
      $qry=sprintf(site_qry9, $frm["ID"]);
		db_query($qry);	
	}

   $qry=sprintf(site_qry6, $frm["ID"]);
	db_query($qry);
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "Address");
}

function fillBankCombo($a, $id)
{
   $b=new BankDetails();
   $b->Combo($a, $id, "bankid");
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "currencyid");
}

function LocaleCombo($action, $id)
{
   $a=new Locale();
   $a->Combo($action, $id, "localeid");
}

function listSite()
{	
	$q=$_SESSION["pageindex"]->query(site_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
   echo "<table border=\"0\" cellpadding=\"0\" width=\"100%\">\n";
   echo "<tr><td>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Site</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$n=$row["name"];
		print "<tr><td>$n</td>";
		print "<td>";
		$wibbler=$row["id"];
		print "<a href=\"site.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"site.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"site.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
