<?php
/*
 * contactdetail.php
 *
 * @version	0.9.6
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2004 Al Kingsley
 * @package	MIS
 * @access	public
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
require_once($_SESSION['CFG']->libdir."/contact.php");

if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], contact_pagetitle)!=0){
   $_SESSION['title']=contact_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(contactdetails_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addItem();
		break;

	case "browse":
		$id=updateNav($_POST);
		browseItem($id);
		break;

	case "edit" :
		editItem($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelItem($_REQUEST['id']);
      }
      else{
         deleteCategory($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listItem();
      }
      break;  
	
   case "cfmdelete" :
      deleteItem($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listItem();
		break;

	case "add" :
		insertItem($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listItem();
		break;

	case "commit" :
		commitItem($_POST);
      listItem();
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listItem();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(contactdetails_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
	$frm["typeid"] = "";
   $frm["data"] = "";
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(contactdetails_qry2, $id);
   }
   else{
      $qry=sprintf(contactdetails_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
   $frm["typeid"] = $row["typeid"];
   $frm["data"] = $row["data"];

	return $frm;
}

function addItem()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   $frm["heading"] = "Contact Details Add";
	
	include("templates/condetail.php");
}

function editItem($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Contact Details Edit";

	include("templates/condetail.php");
}

function browseItem($id) 
{
	$frm=fillForm($id, true);

	$frm["newaction"] = "browse";
   $frm["heading"] = "Contact Details Browse";
	
	include("templates/condetail.php");
}

function insertItem($frm) 
{
   $qry=sprintf(contactdetails_qry4, $frm['typeid'],  $frm['data']);
	db_query($qry);
}

function commitItem($frm) 
{
   $qry=sprintf(contactdetails_qry5, $frm['typeid'],  $frm['data'], $frm['id']);
   db_query($qry);
}

function chkdelItem($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["heading"] = "Contact Details Delete";
   $frm["newaction"] = "cfmdelete";
   
   include("templates/condetail.php");
}

function deleteItem($id) 
{
   $qry=sprintf(contactdetails_qry6, $id);
   db_query($qry);
}

function listItem()
{  
	$q=$_SESSION["pageindex"]->query(contactdetails_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Type</h3></td><td><h3>Data</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
      echo "<tr><td>";
		ContactTypeCombo("browse", $row["typeid"], "");
		echo "</td>\n<td>";
      echo $row["data"];
      echo "</td>\n<td>";
		$wibbler=$row["id"];
		print "<a href=\"contactdetail.php?action=browse&id=$wibbler\">".misc_listadd."</a>&nbsp;\n";
		print "<a href=\"contactdetail.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"contactdetail.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
