<?php

/**
 * Daily report and operations.
 *
 * @package	MIS1
 * @access	public
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2003 Al Kingsley
 *
 * back track of MIS2 module to MIS1 interim release.
 */
require_once("../bhmis.php"); 
require_once($_SESSION['CFG']->libdir."/timedate.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}
if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], daily_rt_pagetitle)!=0){
   $_SESSION['title']=daily_rt_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if(!isset($start_time)){
   $start_ts=& new TimeDate();
   $start_ts->midnight();
   //$start_ts->Set(); // should be pulled from synch table
   $start_time=$start_ts->ansidate();
   $nice_start_time=$start_ts->displayts();
}

if(!isset($end_time)){
   $end_ts=& new TimeDate();
   $result = db_query("SELECT NOW()");
   $row=$result->FetchRow();
   $end_ts->Set($row[0]);
   $end_time=$end_ts->ansidate();
   $nice_end_time=$end_ts->displayts();
}

switch ($_REQUEST['action']){
case 'summary':
   include("templates/daily_summary_rt.php");
   break;

case 'employee':
   include("templates/daily_emp_rt.php");
   break;

case 'station':
   include("templates/daily_station_rt.php");
   break;
   
case 'stock':
   include("templates/daily_stock_rt.php");
   break;
}
   
exit();

function From($type)
{
   $qry=sprintf(daily_rt_qry1, $type);
	$result=db_query($qry);
   
	if(db_num_rows($result)==0){ // no last rec_stock entry
      return false;
   }
   $row=$result->FetchRow();
   $ts=$row[0];
   
   return $ts;
}

function Counts()
{
   global $start_time;
   global $end_time;
   
   $qry=sprintf(daily_qry1, $start_time, $end_time);
	$result=db_query($qry);
   if($result){
      if($row = $result->FetchRow()){
         echo "<tr><td>Total Transactions</td><td align=\"right\">$row[0]</td>";
      }
      else{
         echo "<tr><td>Total Transactions</td><td align=\"right\">0</td>";
      }
   }
   else{
      echo "<tr><td>Total Transactions</td><td align=\"right\">0</td>";
   }
   
   $qry=sprintf(daily_qry2, $start_time, $end_time);
	$result=db_query($qry);
   if($result){
      if($row = $result->FetchRow()){
         if($row[0]){
            echo "<td align=\"right\">$row[0]</td></tr>\n";
         }
         else{
            echo "<td align=\"right\">0.00</td></tr>\n";
         }
      }
   }
   else{
      echo "<td align=\"right\">0.00</td></tr>\n";
   }
   
   $qry=sprintf(daily_qry3, $start_time, $end_time);
	$result=db_query($qry);
   if($result){
      if($row = $result->FetchRow()){
         echo "<tr><td>Total Returns</td><td align=\"right\">$row[0]</td>";
      }
      else{
         echo "<tr><td>Total Returns</td><td align=\"right\">0</td>";
      }
   }
   else{
      echo "<tr><td>Total Returns</td><td align=\"right\">0</td>";
   }
      
   $qry=sprintf(daily_qry4, $start_time, $end_time);
	$result=db_query($qry);   
   if($result){
      if($row = $result->FetchRow()){
         if($row[0]){
            echo "<td align=\"right\">$row[0]</td></tr>\n";
         }
         else{
            echo "<td align=\"right\">0.00</td></tr>\n";
         }
      }
   }
   else{
      echo "<td align=\"right\">0.00</td></tr>\n";
   }
   
   $qry=sprintf(daily_qry5, $start_time, $end_time);
	$result=db_query($qry);
   if($result){
      if($row = $result->FetchRow()){
         echo "<tr><td>Total No Sales</td><td align=\"right\">$row[0]</td><td>&nbsp;</td></tr>";
      }
      else{
         echo "<tr><td>Total No Sales</td><td align=\"right\">0</td><td>&nbsp;</td></tr>";
      }
   }
   else{
      echo "<tr><td>Total No Sales</td><td align=\"right\">0</td><td>&nbsp;</td></tr>";
   }
   
   $qry=sprintf(daily_qry6, $start_time, $end_time);
	$result=db_query($qry);
   if($result){
      if($row = $result->FetchRow()){   
         echo "<tr><td>Total Voids</td><td align=\"right\">$row[0]</td><td>&nbsp;</td></tr>";
      }
      else{
         echo "<tr><td>Total Voids</td><td align=\"right\">0</td><td>&nbsp;</td></tr>";
      }
   }
   else{
      echo "<tr><td>Total Voids</td><td align=\"right\">0</td><td>&nbsp;</td></tr>";
   }
}

function printSummary()
{
   global $start_time;
   global $end_time;
   
   /*
   $pdf = new PDFReport('P','pt','A4');
   $pdf->Watermark("Sample PDF");
   $pdf->Title("Today's Breakdown", "centre", "h1");
   $pdf->SubTitle("Summary","centre", "h3");
   $cols=array("Type"=>80, "Count"=>50, "Value"=>50);
   $pdf->addCols( $cols);
   $cols=array("Type"=>"L", "Count"=>"R", "Value"=>"R");
   $pdf->addLineFormat($cols);
   $y=50;
   */
   $qry=sprintf(daily_qry1, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      //$line = array("Type"=>"Total Transactions", "Count"=>"$row[0]");
   }
   $qry=sprintf(daily_qry2, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      if($row[0]){
         //array_push($line, "Value"=>"$row[0]");
      }
      else{
         //array_push($line, "Value"=>"0.00");
      }
      //$size = $pdf->addLine($y, $line);
      //$y+=$size + 1;
   }
   
   $qry=sprintf(daily_qry3, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      //$line = array("Type"=>"Total Returns", "Count"=>$row[0]");
   }
   
   $qry=sprintf(daily_qry4, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      if($row[0]){
         //array_push($line, "Value"=>"$row[0]");
      }
      else{
         //array_push($line, "Value"=>"0.00");
      }
      //$size = $pdf->addLine($y, $line);
      //$y+=$size + 1;
   }
   
   $qry=sprintf(daily_qry5, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      //$line = array("Type"=>"Total No Sales", "Count"=>"$row[0]", "Value"=>"");
      //$size = $pdf->addLine($y, $line);
      //$y+=$size + 1;
   }
   
   $qry=sprintf(daily_qry6, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){  
      //$line = array("Type"=>"Total Voide", "Count"=>"$row[0]", "Value"=>"");
      //$size = $pdf->addLine($y, $line);
      //$y+=$size + 1;
   }   
}

function SaleCounts()
{
   global $start_time;
   global $end_time;
   
   $qry=sprintf(daily_qry7, $start_time, $end_time);
	$result=db_query($qry);
   if($result){
      if($row = $result->FetchRow()){
         echo "<tr><td>Cash</td><td align=\"right\">$row[0]</td>";
         if($row[1]){
            echo "<td align=\"right\">$row[1]</td></tr>\n";
         }
         else{
            echo "<td align=\"right\">0.00</td></tr>\n";
         }
      }
   }
   else{
      echo "<tr><td>Cash</td><td align=\"right\">0</td>";
      echo "<td align=\"right\">0.00</td></tr>\n";
   }
   
   $qry=sprintf(daily_qry8, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      echo "<tr><td>Credit</td><td align=\"right\">$row[0]</td>";
      if($row[1]){
         echo "<td align=\"right\">$row[1]</td></tr>\n";
      }
      else{
         echo "<td align=\"right\">0.00</td></tr>\n";
      }
   }
   
   $qry=sprintf(daily_qry9, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      echo "<tr><td>Cheque</td><td align=\"right\">$row[0]</td>";
      if($row[1]){
         echo "<td align=\"right\">$row[1]</td></tr>\n";
      }
      else{
         echo "<td align=\"right\">0.00</td></tr>\n";
      }
   }
   
   $qry=sprintf(daily_qry10, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      echo "<tr><td>Other</td><td align=\"right\">$row[0]</td>";
      if($row[1]){
         echo "<td align=\"right\">$row[1]</td></tr>\n";
      }
      else{
         echo "<td align=\"right\">0.00</td></tr>\n";
      }
   }
   
   $qry=sprintf(daily_qry11, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      echo "<tr><td><b><i>Total</i></b></td><td align=\"right\"><b><i>$row[0]</i></b></td>";
      if($row[1]){
         echo "<td align=\"right\"><b><i>$row[1]</i><b></td></tr>\n";
      }
      else{
         echo "<td align=\"right\"><b><i>0.00</i><b></td></tr>\n";
      }
   }
}

function EmployeeSummary()
{
   global $start_time;
   global $end_time;
  
   $qry=sprintf(daily_qry12, $start_time, $end_time);
	$result=db_query($qry);
   
   while($row = $result->FetchRow()){
      echo "<tr><td colspan=\"2\"><b><i>";
      echo $row["fname"] . " " . $row["lname"] . " (" . $row["employeenumber"] . ")";
      echo "</i></b></td></tr>\n<tr><td>Sales</td><td>";
      echo $row["sale_count"];
      echo "</td></tr><td>Value</td><td>\n";
      EmployeeValues($row[0]);
      echo "</td></tr><tr><td>No Sales</td><td>\n";
      EmployeeLog($row[0], "9");
      echo "</td></tr><tr><td>Void Sales</td><td>\n";
      EmployeeLog($row[0], "10");
      echo "</td></tr><tr><td>Logins</td><td>\n";
      EmployeeLog($row[0], "3");
      echo "</td></tr><tr><td>Pay In</td><td>\n";
      Adjustments($row[0], "2");
      echo "</td></tr><tr><td>Pay Out</td><td>\n";
      Adjustments($row[0], "3");
      echo "</td></tr>";
   }
}

function EmployeeValues($emp) 
{
   global $start_time;
   global $end_time;
   
   $qry=sprintf(daily_qry13, $start_time, $end_time, $emp);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      echo "$row[0]";
   }
   else{
      echo "&nbsp;";
   }
}

function EmployeeLog($emp, $action) 
{
   global $start_time;
   global $end_time;

   $qry=sprintf(daily_qry14, $start_time, $end_time, $action, $emp);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      echo $row[0];
   }
}

function Adjustments($emp, $type)
{
   global $start_time;
   global $end_time;
  
   $qry=sprintf(daily_qry15, $start_time, $end_time, $type, $emp);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      if($row[0]!=0)
         echo $row[0];
      else
         echo "0.00";
   }
}

function StationSummary() 
{
   global $start_time;
   global $end_time;
   
   $qry=sprintf(daily_qry16, $start_time, $end_time);
	$result=db_query($qry);
   while($row = $result->FetchRow()){
      echo "<tr><td colspan=\"2\"><b><i>";
      echo $row["postid"] . " - " . $row["name"] . " (" . $row["mac"] . ")";
      echo "</i></b></td></tr>\n<tr><td>Sales</td><td>";
      echo $row["sale_count"];
      echo "</td></tr><td>Value</td><td>\n";
      PostValues($row[4]);
      echo "</td></tr><td>Connects</td><td>\n";
      PostLog($row[0], "1");
      echo "</td></tr><td>Logins</td><td>\n";
      PostLog($row[0], "7");
      echo "</td></tr><td>No Sales</td><td>\n";
      PostLog($row[0], "21");
      echo "</td></tr><td>Void Sales</td><td>\n";
      PostLog($row[0], "22");
      echo "</td></tr><td>Pay In</td><td>\n";
      PostAdjustments($row[4], "2");
      echo "</td></tr><td>Pay Out</td><td>\n";
      PostAdjustments($row[4], "3");
      echo "</td></tr>";
   }
}

function PostValues($post) 
{
   global $start_time;
   global $end_time;
   
   $qry=sprintf(daily_qry17, $start_time, $end_time, $post);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      if($row[0]!=0)
         echo $row[0];
      else
         echo "0.00";
   }
}

function PostLog($post, $action) 
{
   global $start_time;
   global $end_time;
  
   $qry=sprintf(daily_qry18, $post, $start_time, $end_time, $action);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      echo $row["action_count"];
   }
   else{
      echo "0";
   }
}

function PostAdjustments($post, $type)
{
   global $start_time;
   global $end_time;
   
   $qry=sprintf(daily_qry19, $start_time, $end_time, $type, $post);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      if($row[0]!=0)
         echo $row[0];
      else
         echo "0.00";
   }
}

function BankSummary()
{
   global $start_time;
   global $end_time;
   
   $qry=sprintf(daily_qry20, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      echo "<tr><td>Cash</td><td align=\"right\">$row[0]</td>";
      if($row[1]){
         echo "<td align=\"right\">$row[1]</td></tr>\n";
      }
      else{
         echo "<td align=\"right\">0.00</td></tr>\n";
      }
   }
   $qry=sprintf(daily_qry21, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      echo "<tr><td>Cheque</td><td align=\"right\">$row[0]</td>";
      if($row[1]){
         echo "<td align=\"right\">$row[1]</td></tr>\n";
      }
      else{
         echo "<td align=\"right\">0.00</td></tr>\n";
      }
   }
}

function BankEntry()
{
   global $start_time;
   global $end_time;
   
   $qry=sprintf(daily_qry22, $start_time, $end_time);
	$result=db_query($qry);

   if($row = $result->FetchRow()){
      echo "<tr><td>Cash</td><td align=\"right\">$row[0]</td>";
      if($row[1]){
         echo "<td align=\"right\">$row[1]</td></tr>\n";
      }
      else{
         echo "<td align=\"right\">0.00</td></tr>\n";
      }
   }
   $qry=sprintf(daily_qry23, $start_time, $end_time);
	$result=db_query($qry);
   if($row = $result->FetchRow()){
      echo "<tr><td>Cheque</td><td align=\"right\">$row[0]</td>";
      if($row[1]){
         echo "<td align=\"right\">$row[1]</td></tr>\n";
      }
      else{
         echo "<td align=\"right\">0.00</td></tr>\n";
      }
   }
}

function BalanceSummary()
{
}

function ReconcileStock()
{
   global $start_time;
   global $end_time;
   
   $qry=sprintf(daily_qry24, $start_time, $end_time);
	$result=db_query($qry);
   
   while($row = $result->FetchRow()){
      echo "<tr><td>$row[0]</td>\n";
      $qry=sprintf(daily_qry25, $row[0]);
	   $presult=db_query($qry);
      if($prow = $presult->FetchRow()){
         $qry=sprintf(daily_qry26, $prow[0]);
	      $iresult=db_query($qry);
         if($irow = $iresult->FetchRow()){
            echo "<td align=\"right\">$irow[1]</td>\n";
            echo "<td align=\"right\">$row[1]</td>\n";
            $nq=$irow["instock"] - $row[1];
         
            if($nq < $irow["rolevel"])
               echo "<td align=\"right\"><font color=\"FF0000\">$nq</font></td>";
            else 
               echo "<td align=\"right\">$nq</td>";
         }
         else{
            echo "<td>&nbsp;</td>";
         }
         echo "<td align=\"right\">$irow[2]</td>\n";
         echo "<td align=\"right\">$irow[3]</td>\n";
      }
      echo "</tr>";
   /*
      $presult=db_query("UPDATE InStock from inventory set InStock='(InStock-$row[qty])' WHERE
          inventory.id='product.invID' AND
          product.PLU='$row[PLU]'");
      }*/
   }
}

function StockLevels()
{
   global $start_time;
   global $end_time;
   $qry=sprintf(daily_qry27);
	$result=db_query($qry);
   
   while($row = $result->FetchRow()){
   }
}

?>
