<?php
/*
 * An account entity.
 *
 * @version	0.9.6
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2003 Al Kingsley
 * @package	MIS
 * @access	public
 */

class Account
{
   var $id;
   var $parentid;
   var $accountnumber;
   var $name;
   var $title;
   var $gref;
   
   function Account($id=false)
   {
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      
      $this->id=0;
      $this->parentid=0;
	   $this->accountnumber='';
   	$this->name='';
	   $this->title=0;
      $this->gref=0;
   }
   
   function GetID() { return $this->id; }
   
   function Fill($id, $bOffset)
   {
      if($id==0){
         return false;
      }
      
      if($bOffset){
         $qry=sprintf(account_qry2, $id);
      }
      else{
         $qry=sprintf(account_qry3, $id);
      }

	   $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->parentid=$row["parentid"];
	      $this->accountnumber=$row["accountnumber"];
   	   $this->name=$row["name"];
	      $this->title=$row["title"];
         $this->gref=$row["gref"];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e,$f)
   {
      $this->id=$a;
      $this->parentid=$b;
	   $this->accountnumber=$c;
   	$this->name=$d;
	   $this->title=$e;
      $this->gref=$f;
   }
   
   function SetFromForm($frm)
   {
      $this->parentid=$frm["parentid"];
	   $this->accountnumber=$frm["accountnumber"];
   	$this->name=$frm["name"];
	   $this->title=$frm["title"];
      $this->gref=$frm["gref"];
   }
   
   function Add()
   {
      $qry=sprintf(account_qry5, $this->parentid,$this->accountnumber,$this->name,$this->title,$this->gref);
      db_query($qry);
       
       $this->ID=db_insert_id();
       return $this->ID;
   }
   
   function Commit($id)
   {
      $qry=sprintf(account_qry7, $this->parentid,$this->accountnumber,$this->name,$this->title,$this->gref, $id);
      db_query($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(account_qry7, $this->id);
      db_query($qry);
   }
   
   function Combo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\" width=\"250\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $result=db_query(account_qry4);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
            break;
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(account_qry3, $id);
         $result=db_query($qry);
      	if($row = $result->FetchRow()){
		      $poo=$row["name"];
            echo $poo;
         }
         else echo "Not Set";
      }
   }
   
   function TypeCombo($a, $type, $cname)
   {
	   $typelist=array(0=>'Income',1=>'Expense',2=>'Asset',3=>'Liability',4=>'Capital');
   
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\" width=\"250\">\n";
	      foreach($typelist as $n=>$typeid){
	         echo "<option ";
      	   if($type==$typeid)
	            echo "selected ";
	         echo "value='$n'>$typeid</option>\n";
	      }
	      echo "</select>\n";
      }
      else{
         if(isset($type)){
            echo $typelist[$type];
         }
         else echo "Not Set";
      }
   }
   
   function HeadingCombo($a, $id, $cname)
   {
      /*
      if($this->ID==0){
         $this->Fill($id, false);
      }
      */
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\" width=\"250\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $result=db_query(acchead_qry7);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(acchead_qry3, $id);
         $result=db_query($qry);
      	if($row = $result->FetchRow()){
		      $poo=$row["name"];
            echo $poo;
         }
         else echo "Not Set";
      }
   }
   
   function Table($a, $id, $title, $bInside=false)
   {
      if($this->id==0){
         $this->Fill($id, false);
      }
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"address\">\n";
         echo "<tr>\n";
	      echo "<td colspan=\"2\" align=\"center\"><h3>$title</h3></td></tr>\n";
      }
      
      $parentid;
	   echo "<tr>\n";
      echo "<td width=\"20%\" align=\"right\">Parent</td>\n";
      echo "<td>";
	   //entry($a, "Address1", 68, 64, $this->Address1);
   	echo"</td>\n";
	   echo "</tr>\n";
	
      $accountnumber;
   	echo "<tr>\n";
      echo "<td align=\"right\">Account Number</td>\n";
      echo "<td>";
	   //entry($a, "Address2", 68, 64, $this->Address2);
   	echo"</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td align=\"right\">Address 3</td>\n";
   	echo "<td>";
      entry($a, "name", 68, 64,$this->name);
   	echo"</td>\n";
	   echo "</tr>\n";

      $title;
   	echo "<tr>\n";
      echo "<td align=\"right\">Title</td>\n";
      echo "<td>";
	   //entry($a, "City", 68, 64, $this->City);
   	echo "</td>\n";
	   echo "</tr>\n";
   
      $gref;
      echo "<tr>\n";
      echo "<td align=\"right\">Gov. Ref.</td>\n";
      echo "<td>";
	   //entry($a, "State", 32, 32, $this->State);
   	echo "</td>\n";
	   echo "</tr>\n";

      if(!$bInside){
   	   echo "</table>\n";
      }
   }
   
   function Find($bOutput)
   {  
      return false;
   }
}

?>
