<?php
/*
 * An address thingy.
 *
 * @version	0.9.6
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2003 Al Kingsley
 * @package	MIS
 * @access	public
 */

class Address
{
   var $id;
   var $address1;
	var $address2;
	var $address3;
	var $city;
   var $state;
	var $postcode;
	var $country;
   
   function Address($id=false)
   {
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      $this->id=0;
      $this->address1='';
	   $this->address2='';
      $this->address3='';
	   $this->city='';
      $this->state='';
      $this->postcode='';
	   $this->country='';
   }
   
   function Getid() { return $this->id; }
   
   function Fill($id, $bOffset=true)
   {
      if($id==0){
         return false;
      }
      if($bOffset){
         $qry=sprintf(address_qry2, $id);
      }
      else{
         $qry=sprintf(address_qry3, $id);
      }
      
	   $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->address1=$row["address1"];
         $this->address2=$row["address2"];
         $this->address3=$row["address3"];
         $this->city=$row["city"];
         $this->state=$row["state"];
	      $this->postcode=$row["postcode"];
	      $this->country=$row["country"];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e,$f,$g)
   {
      $this->address1=$a;
	   $this->address2=$b;
   	$this->address3=$c;
	   $this->city=$d;
      $this->state=$e;
   	$this->postcode=$f;
	   $this->country=$g;
   }
   
   function setfromform($frm)
   {
      $this->address1=$frm['address1'];
	   $this->address2=$frm['address2'];
   	$this->address3=$frm['address3'];
	   $this->city=$frm['city'];
      $this->state=$frm['state'];
   	$this->postcode=$frm['postcode'];
	   $this->country=$frm['country'];
   }
   
   function Add()
   {
      $qry=sprintf(address_qry4, $this->address1,$this->address2,$this->address3,$this->city,
         $this->state,$this->postcode,$this->country);
      db_query($qry);
       
       $result=db_query(misc_qry1);
       if($row = $result->FetchRow()){
          $this->id=$row[0];
       }
       return $this->id;
   }
   
   function Commit($id)
   {
      $qry=sprintf(address_qry5, $this->address1,$this->address2,$this->address3,$this->city,
         $this->state,$this->postcode,$this->country, $id);
      db_query($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(address_qry6, $this->id);
      db_query($qry);
   }
   
   function FillTable($a, $id, $title, $bInside=false)
   {
      if($a=="commit" || $a=="add"){
         $this->Fill($id, false);
      }
      else{
         $this->Fill($id, true);
      }
      
      if(!$bInside){
         echo "<table class=\"address\">\n";
         echo "<th colspan=\"2\">$title</th>\n";
      }

	   echo "<tr>\n";
      echo "<td class=\"label\">".address_address1."</td>\n";
      echo "<td>";
	   entry($a, "address1", 68, 64, $this->address1);
   	echo"</td>\n";
	   echo "</tr>\n";
	
   	echo "<tr>\n";
      echo "<td class=\"label\">".address_address2."</td>\n";
      echo "<td>";
	   entry($a, "address2", 68, 64, $this->address2);
   	echo"</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td class=\"label\">".address_address3."</td>\n";
   	echo "<td>";
      entry($a, "address3", 68, 64,$this->address3);
   	echo"</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td class=\"label\">".address_city."</td>\n";
      echo "<td>";
	   entry($a, "city", 68, 64, $this->city);
   	echo "</td>\n";
	   echo "</tr>\n";
   
      echo "<tr>\n";
      echo "<td class=\"label\">".address_state."</td>\n";
      echo "<td>";
	   entry($a, "state", 32, 32, $this->state);
   	echo "</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td class=\"label\">".address_postcode."</td>\n";
      echo "<td>";
	   entry($a, "postcode", 32, 32, $this->postcode);
   	echo "</td>\n";
	   echo "</tr>\n";
	
   	echo "<tr>\n";
      echo "<td class=\"label\">".address_country."</td>\n";
      echo "<td>";
	   entry($a, "country", 32, 32, $this->country);
   	echo "</td>\n";
	   echo "</tr>\n";
      if(!$bInside){
   	   echo "</table>\n";
      }
   }
   
   function Find($bOutput)
   {
      $band=0;
      $ba1=0;
      $ba2=0;
      $ba3=0;
      $bc=0;
      $bs=0;
      $bp=0;
      $bcn=0;
      
      $query="SELECT * FROM address WHERE ";
      if($this->address1!=''){
         $query.="address1='$this->address1'";
         $ba1=1;
         $band=1;
      }
      if($this->address2!=''){
         if($band==0){
            $query.="address2='$this->address2'";
            $band=1;
         }
         else{
            $query.="and address2='$this->address2'";
         }
         $ba2=1;
      }
      if($this->address3!=''){
         if($band==0){
            $query.="address3='$this->address3'";
            $band=1;
         }
         else{
            $query.="and address3='$this->address3'";
         }
         $ba3=1;
      }
      if($this->city!=''){
         if($band==0){
            $query.="city='$this->city'";
            $band=1;
         }
         else{
            $query.="and city='$this->city'";
         }
         $bc=1;
      }
      if($this->state!=''){
         if($band==0){
            $query.="state='$this->state'";
            $band=1;
         }
         else{
            $query.="and state='$this->state'";
         }
         $bs=1;
      }
      if($this->postcode!=''){
         if($band==0){
            $query.="postcode='$this->postcode'";
            $band=1;
         }
         else{
            $query.="and postcode='$this->postcode'";
         }
         $bp=1;
      }
      if($this->country!=''){
         if($band==0){
            $query.="country='$this->country'";
            $band=1;
         }
         else{
            $query.="and country='$this->country'";
         }
         $bcn=1;
      }
      
      $result=db_query($query);
      $n=db_num_rows($result);
      if(!$bOutput){
         if($n==0){
            return false;
         }
         else{
            return true;
         }
      }
      
      if($n==0){
         echo "<br><br><center><h2>No matching Address found for search Criteria</h2></center>";
         return false;
      }
      
      echo "<table width=\"100%\"><tr><td colspan=\"6\" align=\"center\"><h3>Found $n Matches</h3></td></tr>\n";
      echo "<tr><td><h3>Address1</h3></td><td><h3>Address2</h3></td><td><h3>Address3</h3></td>\n";
      echo "<td><h3>City</h3></td><td><h3>State</h3></td><td><h3>Post Code</h3></td><td><h3>Country</h3></td>\n";
      while($row = $result->FetchRow()){
         echo "<tr><td>\n";
         if($ba1){
            echo "<b>$row[address1]</b>";
         }
         else{
             echo $row['address1'];
         }
         echo "</td><td>";
         if($ba2){
            echo "<b>$row[address2]</b>";
         }
         else{
            echo $row['address2'];
         }
         echo "</td><td>";
         if($ba3){
            echo "<b>$row[address3]</b>";
         }
         else{
            echo $row['address3'];
         }
         echo "</td><td>";
         if($bc){
            echo "<b>$row[city]</b>";
         }
         else{
            echo $row['city'];
         }
         echo "</td><td>";
         if($bs){
            echo "<b>$row[state]</b>";
         }
         else{
            echo $row['state'];
         }
         echo "</td><td>";
         if($bp){
            echo "<b>$row[postcode]</b>";
         }
         else{
            echo $row['postcode'];
         }
         echo "</td><td>";
         if($bcn){
            echo "<b>$row[country]</b>";
         }
         else{
            echo $row['country'];
         }
         echo "</td></tr>\n";
      }
      echo "</table>\n";
      
      return true;
   }
}

?>
