<?
/*
conf.php - conf file parser

Copyright (C) 2003 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 - 2003 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

class conffile
{
   var $filename;
   var $bLock = true;
   var $lockfile;

   function conffile($filename)
   {
      $this->filename = $filename;
      $this->lockfile = $filename.".lock";

      if((!file_exists($this->filename)) && (!$this->file_test())){
         $this = false;
         return $this;
      }
   }

   function enum_sections()
   {
      $ret = array();
      if($ifile = @file($this->filename)){
         foreach($ifile as $vValue){
            if(ereg("^[ \t]*\[[^]]*\].*",$vValue)){
               $secexist = false;
               $buf = trim(ereg_replace("[ \t]*\[*([^]]*)\].*","\\1",$vValue));
               for($i=0; $i < count($ret); $i++){
                  if($buf==$ret[$i]){
                     $secexist = true;
                  }
               }
               if(!$secexist){
                  $ret[count($ret)] = $buf;
               }
            }
         }
      }
      return $ret;
   }

   function enum_keys($Section)
   {
      $ret = array();
      $secfound = false;

      $SEC = preg_quote($Section);

      if($ifile = @file($this->filename)){
         foreach ($ifile as $vValue){
            $vValue=ereg_replace("(\n|\r)","",$vValue);
            if (ereg("^[ \t]*\[[^]]*\].*$",$vValue)){
               $secfound = false;
            }
            if(ereg("^[ \t]*\[".$SEC."\].*$",$vValue)){
               $secfound = true;
            }
            if(ereg('^[ \t]*[^;]+=.*$',$vValue)){
               if($secfound){
                  $keyexist = false;
                  $buf = ereg_replace("[ \t]*(.*)[ \t]*=.*","\\1",$vValue);
                  for($i=0; $i<count($ret); $i++){
                     if($buf==$ret[$i]){
                        $keyexist = true;
                     }
                  }
                  if(!$keyexist){
                     $ret[count($ret)] = $buf;
                  }
               }
            }
         }
      }
      return $ret;
    }

   function get_key($section, $keyname, $default=false)
   {
      $ret = $default;
      $secfound = false;
      $SEC = preg_quote($section);
      $KEY = preg_quote($keyname);

      if($ifile = @file($this->filename)){
         foreach($ifile as $vValue){
            if(ereg("^[ \t]*\[[^]]*\].*$",$vValue)){
               $secfound = false;
            }
            if(ereg("^[ \t]*\[".$SEC."\].*$",$vValue)){
               $secfound = true;
            }
            if(ereg("^[ \t]*".$KEY."[ \t]*=.*$",$vValue)){
               if($secfound){
                  $buf =  ereg_replace("^.*".$KEY."[ \t]*=(.*)$","\\1",$vValue);
                  $buf = ereg_replace("(\n|\r)*","",$buf);
                  $pos = strpos($buf, '#');
                  if($pos === false){
                  }
                  else{
                     $buf=substr_replace($buf, '', $pos);
                  }
                  $ret = trim($buf);
                  return $ret;
               }
            }
         }
      }
      return $ret;
    }

   function set_key($section, $keyname, $NewValue)
   {
      global $HTTP_SERVER_VARS;
      $ret = false;
      $secstart = false;
      $secend   = false;
      $outbuf = array();
      $i=0;
      $done = false;
      $SEC = preg_quote($section);
      $KEY = preg_quote($keyname);

      $this->write_lockfile();

      if($ifile = @file($this->filename)){
         foreach ($ifile as $vValue){
            $i = $i + 1;
            $buf = ereg_replace("(\n|\r)*","",$vValue);
            $outbuf[count($outbuf)] = $buf;
            if(!$done){
               if(ereg("^[ \t]*\[[^]]*\].*\$",$buf)){ // Section found
                  if($secstart){
                     $secstart = false;
                     $secend = true;
                  }
               }
               if(ereg("^[ \t]*\[".$SEC."\].*\$",$buf)){ // Specified Section found
                  $secstart = true;
                  $secend = false;
               }
               if(ereg("^[ \t]*".$KEY."[ \t]*=.*\$",$buf) && $secstart){ // Key Found
                  $outbuf[count($outbuf)-1] = $keyname." = ".$NewValue;
                  $secstart = false;
                  $done = true;
                  continue;
               }
               if($secstart && $secend){
                  $outbuf[count($outbuf)] = $keyname." = ".$NewValue;
                  $secstart = false;
                  $secend = false;
                  $done = true;
                  continue;
               }
               if($i == count($ifile)){
                  if($secstart){
                     $outbuf[count($outbuf)] = $keyname." = ".$NewValue;
                     $secstart = false;
                     $secend = false;
                     $done = true;
                     continue;
                  }
                  else{
                     $outbuf[count($outbuf)] = "[".$section."]";
                     $outbuf[count($outbuf)] = $keyname." = ".$NewValue;
                  }
               }
            }
         }
      }
      if(count($outbuf) == 0){
         $outbuf[0] = "[".$section."]";
         $outbuf[1] = $keyname." = ".$NewValue;
      }
      $ret = $this->write_array_to_file($outbuf);
      $this->delete_lockfile();

      return $ret;
   }

   function write_array_to_file($WArray)
   {
      $ret = false;
      if($ofile = @fopen($this->filename,'w')){
         foreach($WArray as $vValue){
            $buf = $vValue."\n";
            fputs($ofile, $buf, strlen($buf));
         }
         fclose($ofile);
         $ret = true;
      }
      return $ret;
   }

   function del_key($section,$keyname)
   {
      global $HTTP_SERVER_VARS;
      $ret = false;
      $secstart = false;
      $secend   = false;
      $outbuf = array();
      $i=0;
      $done = false;
      $SEC = preg_quote($section);
      $KEY = preg_quote($keyname);

      $this->write_lockfile();

      if($ifile = @file($this->filename)){
         for ($i=0;$i<count($ifile);$i++){
            $ifile[$i] = ereg_replace("(\n|\r)*","",$ifile[$i]);
            $ifile[$i] = ereg_replace("(\n|\r)*","",$ifile[$i]);
            if(ereg("^[ \t]*\[[^]]*\].*\$",$ifile[$i])){ // Section found
               if($secstart){
                  $secstart = false;
                  $secend = true;
               }
            }
            if(ereg("^[ \t]*\[".$SEC."\].*\$",$ifile[$i])){ // Specified Section found
               $secstart = true;
               $secend = false;
            }
            if(ereg("^[ \t]*".$KEY."[ \t]*=.*\$",$ifile[$i]) && $secstart){ // Key Found
               continue;
            }
            else{
               $outbuf[count($outbuf)] = $ifile[$i];
            }
         }
      }
      $ret = $this->write_array_to_file($outbuf);
      $this->delete_lockfile();
      
      return $ret;
   }

   function del_sec($section)
   {
      global $HTTP_SERVER_VARS;
      $ret = false;
      $secstart = false;
      $secend   = false;
      $outbuf = array();
      $SEC = preg_quote($section);

      $this->write_lockfile();

      if($ifile = @file($this->filename)){
         for($i=0;$i<count($ifile);$i++){
            $ifile[$i] = ereg_replace("(\n|\r)*","",$ifile[$i]);
            $ifile[$i] = ereg_replace("(\n|\r)*","",$ifile[$i]);
            if(ereg("^[ \t]*\[[^]]*\].*\$",$ifile[$i])){ // Section found
               if($secstart){
                  $secstart = false;
                  $secend = true;
               }
            }
            if(ereg("^[ \t]*\[".$SEC."\].*\$",$ifile[$i])){ // Specified Section found
               $secstart = true;
               $secend = false;
            }
            if(!$secstart){
               $outbuf[count($outbuf)] = $ifile[$i];
            }
         }
      }
      $ret = $this->write_array_to_file($outbuf);
      $this->delete_lockfile();

      return $ret;
   }
   function listall()
   {
      $ret = false;
      $tarr = $this->enum_sections();
      foreach ($tarr as $vValue){
         $ret .= "[".$vValue."]"."\n";
         $t1arr = $this->enum_keys($vValue);
         foreach ($t1arr as $vvValue){
            $this->get_key($vValue,$vvValue);
            $ret .= $vvValue." = ".$this->get_key($vValue,$vvValue)."\n";
         }
      }
      return $ret;
   }

   function file_test()
   {
      global $HTTP_SERVER_VARS;
      $ret = false;
      if($fp = @fopen($this->filename,"w")){
         fclose($fp);
         unlink($this->filename);
         $ret = true;
      }
      return $ret;
   }
  
   function write_lockfile()
   {
      if($this->bLock){
         if(file_exists($this->lockfile)){
            $EX = true;
         }
         else{
            $EX = false;
         }
         while($EX){
            if(!file_exists($this->lockfile)) { $EX = false; }
         }
         $fp = fopen($this->lockfile,"w");
         fclose($fp);
      }
      $ret = true;
      return $ret;
   }
   
   function delete_lockfile()
   {
    if($this->bLock){
         unlink($this->lockfile);
     }
   }
}
?>
