<?php
/*
 * An iage thingy.
 *
 * @version	0.9.7
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2004 Al Kingsley
 * @package	MIS
 * @access	public
 */

class Image
{
   var $id;
   var $type;
   var $reffile;
   var $width;
   var $height;
   var $bbp;
   var $scale;
   
   function Image($id=false)
   {
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      $this->id='';
      $this->type='';
      $this->reffile='';
      $this->width='';
      $this->height='';
      $this->bbp='';
      $this->scale='';
   }
   
   function Getid() { return $this->id; }
   
   function Fill($id, $bOffset=true)
   {
      if($id==0){
         return false;
      }
      if($bOffset){
         $qry=sprintf(image_qry2, $id);
      }
      else{
         $qry=sprintf(image_qry3, $id);
      }
      
	   $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->type=$row["type"];
         $this->reffile=$row["reffile"];
         $this->width=$row["width"];
         $this->height=$row["height"];
         $this->bbp=$row["bbp"];
         $this->scale=$row["scale"];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e,$f)
   {
      $this->type=$a;
      $this->reffile=$b;
      $this->width=$c;
      $this->height=$d;
      $this->bbp=$e;
      $this->scale=$f;
   }
   
   function setfromform($frm)
   {
      $this->type=$frm['type'];
      $this->reffile=$frm['reffile'];
      $this->width=$frm['width'];
      $this->height=$frm['height'];
      $this->bbp=$frm['bbp'];
      $this->scale=$frm['scale'];
   }
   
   function Upload($userfile, $newfile, $directory, $width, $height, $quality='100', $smooth='10', $extention='AUTO') 
   {
      $imgsize = GetImageSize($userfile);
      if(($imgsize[0] > $width) || ($imgsize[1] > $height)){
         $tmpimg = tempnam("/tmp", "MKUP");
         system("djpeg $userfile >$tmpimg");
         system("pnmscale -xy $width $height $tmpimg | cjpeg -smoo $smooth -qual $quality  >$userfile");
         unlink($tmpimg);
      }
      $mimetype = $_FILES['userfile']['type'];
    
      if($extention == "AUTO"){
         if(($mimetype == "image/x-png") || ($mimetype == "image/png")){
            $extention = "png";
         }
         elseif($mimetype == "image/pjpeg"){
            $extention = "jpg";
         }
         elseif($mimetype == "image/gif"){
            return "";
         }
         else{
            $extention = "";
            $error_message = "Please upload images with the extension .jpg or .jpeg or .png only";
         }
      }
      if(strstr($mimetype, "image/")){
         $newfile_name = $newfile.".".$extention;
         $newfile = $directory.$newfile_name;
         if(is_uploaded_file($userfile)){
            if(!copy($userfile, $newfile)){
               $error_message = "Error Uploading File.";
            }
        }
        return $newfile_name;
      }
      else{
        $error_message = "Not An Image";
      }
   } 
   
   function Add()
   {
      /*
      $size = getimagesize($_FILES['reffile']['tmp_name']);
      $w=$size[0];
      $h=$size[1];
   
      $qry=sprintf(image_qry4, image_qry5, $frm['type'],$f,$w,$h,$frm['bbp'],$frm['scale']);
      db_query($qry);
       
       $result=db_query(misc_qry1);
       if($row = $result->FetchRow()){
          $this->id=$row[0];
       }
       */
       return $this->id;
   }
   
   function Commit($id)
   {
      $qry=sprintf(image_qry6, $frm['type'],$f,$w,$h,$frm['bbp'],$frm['scale'],$frm['id'], $id);
      db_query($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(image_qry7, $this->id);
      db_query($qry);
   }
   
   function TypeCombo($a, $cname, $type)
   {
      if($a=="commit" || $a=="add"){
   	   echo "<select name=\"$cname\" width=\"150\">";
         if($this->type==BHSQL_IMAGEDATA_PERSON){
            echo "<option selected value=\"BHSQL_IMAGEDATA_PERSON\"> Person </option>";
            echo "<option value=\"BHSQL_IMAGEDATA_PRODUCT\"> Product </option>";
         }
         else{
            echo "<option value=\"BHSQL_IMAGEDATA_PERSON\"> Person </option>";
            echo "<option selected value=\"BHSQL_IMAGEDATA_PRODUCT\"> Product </option>";
         }
         echo "</select>";
   	}
	   else{
         echo $this->type;
   	}
   }
   
   function Thumbnailer($filename)
   {
      if(!isset($filename)){
         define("SIZE", 120);
         define("COLNUM", 6);
         $dir = ($dir)?$dir:"." ;
         echo "<html>\n<head>\n<title>Browse <?= $dir ?></title>\n<style type=\"text/css\">\n";
         echo "<!--\n table{ width:100%; }\n td{ text-align:center; } \n img{ border:none; }\n -->\n";
         echo "</style>\n</head>\n<body>\n<table>\n";
         $dd=opendir($dir);
         for($i=0; $filename=readdir($dd);){
            if(is_file("$dir/$filename")){
               if($imgSize = getImageSize("$dir/$filename")){
                  $w0 = $imgSize[0] ;
                  $h0 = $imgSize[1] ;
                  $imgType = $imgSize[2] ;
                  $ratio = $w0 / $h0 ;
                  if($ratio > 1){
                     $w1=SIZE ;
                     $h1=(SIZE * $h0) / $w0 ;
                  }
                  else{
                     $w1=(SIZE * $w0) / $h0 ;
                     $h1=SIZE ;
                  }
                  $params=sprintf("filename=$dir/$filename&w0=$w0&h0=$h0&imgType=$imgType&h1=%d&w1=%d",$h1,$w1);
                  if(!($i % COLNUM)){
                     echo "\n<tr>\n" ;
                  }
                  echo "<td><a href=\"$dir/$filename\">\n";
                  echo "<img src=\"$PHP_SELF?$params style=\"width: $w1 ;height: $h1 ;\"></a><br>\n";
                  echo "$filename : $w0 x $h0\n";
                  $i++ ;
                }
             }
         }
         echo "</table>\n</body>\n</html>n";
         closedir($dd) ;
      }
      else{
         switch($imgType){
         case 1: $imgType = "gif" ; break;
         case 2: $imgType = "JPEG" ; break;
         case 3: $imgType = "png" ; break;
         default:  break;
         }
         header("Content-type: image/$imgType") ;
         $tImg = imageCreate( $w1 , $h1 ) ;
         $imgOpenFunc = "imageCreateFrom".$imgType ;
         $imgSendFunc = "image".$imgType ;
         $img = $imgOpenFunc("$filename") ;
         imageCopyResized( $tImg , $img , 0 , 0 , 0 , 0 , $w1 , $h1 , $w0 , $h0 ) ;
         imageDestroy($img) ;
         $imgSendFunc($tImg) ;
      }
   }
   
   function Table($a, $id, $title, $bInside=false)
   {
      if($a=="commit" || $a=="add"){
         $this->Fill($id, false);
      }
      else{
         $this->Fill($id, true);
      }
      
      if(!$bInside){
         echo "<table class=\"image\">\n";
         echo "<th colspan=\"2\">$title</th>\n";
      }

	   echo "<tr>\n";
      echo "<td class=\"label\">".image_type."</td>\n";
      echo "<td>";
      TypeCombo($a, 'type', $this->type);
   	echo"</td>\n";
	   echo "</tr>\n";
	
   	echo "<tr>\n";
      echo "<td class=\"label\">".image_reffile."</td>\n";
      echo "<td>";
	   entry($a, "reffile", 68, 64, $this->reffile);
   	echo"</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td class=\"label\">".image_width."</td>\n";
   	echo "<td>";
      entry($a, "width", 8, 8,$this->width);
   	echo"</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td class=\"label\">".image_height."</td>\n";
      echo "<td>";
	   entry($a, "height", 8, 8, $this->height);
   	echo "</td>\n";
	   echo "</tr>\n";
   
      if(!$bInside){
   	   echo "</table>\n";
      }
   }
   
   function Find($bOutput)
   {
      $qry=sprintf(image_qry8, $this->reffile);
      $query=db_query($qry);
            
      return true;
   }
}

?>
