<?
/*
items.php - general lists

Copyright (C)2003 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001, 2002, 2003 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
define("ITEMTYPE_UNKNOWN", 0);
define("ITEMTYPE_UPLU", 1);
define("ITEMTYPE_PLU", 2);
define("ITEMTYPE_PRICE", 3);
define("ITEMTYPE_DESCPRICE", 4);
define("ITEMTYPE_ALL", 5);
define("ITEMTYPE_RETURN", 6);
define("ITEMTYPE_LAYBY", 7);
define("ITEMTYPE_DETAIL", 8);
define("ITEMTYPE_DELIVERY", 9);
define("ITEMTYPE_UNDELIVERED", 10);
define("ITEMTYPE_RENTAL", 11);
define("ITEMTYPE_RENTALRETURN", 12);
define("ITEMTYPE_EPHEMERAL", 13);
define("ITEMTYPE_PURCHASE", 14);
define("ITEMTYPE_DISPATCH", 15);
define("ITEMTYPE_TRANSFERIN", 16);
define("ITEMTYPE_TRANSFEROUT", 17);
   
class InvItem
{
	var $invID;
	var $productID;
	var $plu;
   var $type;
	var $name;
	var $qty;
	var $costprice;
	var $supplierID;
	var $flags;
   var $status;

	function InvItem()
	{
		$this->init();
	}

	function init()
	{
		$this->invID=0;
		$this->productID=0;
		$this->plu="";
      $this->type=ITEMTYPE_UNKNOWN;
		$this->name="";
		$this->qty=1;
		$this->price=0.00;
		$this->supplierID=0;
		$this->flags=0;
      $this->status='unknown';
	}

	function CheckPLU()
	{
		if(!isset($this->plu) || $this->plu==""){
			return 1;
		}
		$result=db_query("SELECT ID, InvID, PLU, name from product WHERE PLU='$this->plu'");
		if(db_num_rows($result)==0){
			return 2;
		}
		$row = $result->FetchRow();
		$this->productID=$row["ID"];
		$this->name=$row["name"];
		$this->invID=$row["InvID"];
		db_free_result($result); 
		
		$result=db_query("SELECT ID, buyquantitypriceid from inventory WHERE ID='$this->invID'");
		if(db_num_rows($result)==0){
			return 3;
		}
		$row = $result->FetchRow();
		$bqid=$row["buyquantitypriceid"];
		db_free_result($result); 

		$result=db_query("SELECT Price, SupplierID FROM invpricequantity WHERE ID = '$bqid'");
		if(db_num_rows($result)==0){
			return 4;
		}
		$row = $result->FetchRow();
		$this->price=$row["Price"];
		$this->supplierID=$row["SupplierID"];
		db_free_result($result); 
		
		return 0;
	}

	function Total()
	{
		return (float) $this->qty * $this->price;
	}

	function GetInvID() { return $this->invID; }
	function GetProdID() { return $this->productID; }
	function GetPLU() { return $this->plu; }
	function GetName() { return $this->name; }
	function GetQty() { return $this->qty; }
	function GetPrice() { return $this->price; }
	function GetSupplier() { return $this->supplierID; }
	function GetFlags() { return $this->flags; }
   function GetStatus() { return $this->status; }

	function SetInvID($iid) { $this->invID=$iid; }
	function SetProdID($pid) { $this->productID=$pid; }
	function SetPLU($p) { $this->plu=$p; }
	function SetName($n) { $this->name=$n; }
	function SetQty($q) { $this->qty=$q; }
	function SetPrice($p) { $this->price=$p; }
	function SetSupplier($s) { $this->supplierID=$s; }
	function SetFlags($f) { $this->flags=$f; }
   function SetStatus($s) 
   {
      switch($s){
      case 'unknown':
      case 'ok':
      case 'missing':
      case 'damaged':
      case 'wrongitem':
      case 'underqty':
      case 'overqty':
         $this->status=$s; 
         return false;
      }
      return true;
   }
}

class InvItems
{
	var $num_items;
	var $supplierID;
	var $items;	
	var $curr_item;
	var $total;

	function InvItems()
	{
		$this->init();
	}

	function init() 
	{
		$this->num_items = 0;
		$this->supplierID = 0;
		$this->items = array();
		$this->curr_item = 0;
		$this->total = 0.00;
	}

	function cleanup() 
	{
		foreach($this->items as $i){
			unset($this->items[$i]);
		}
	}

	function Add($InvItem) 
	{
		$found=0;

		if(isset($InvItem)){
			if(count($this->items)!=0){
				foreach($this->items as $num=>$ii){
					$plu=$ii->GetPLU();
					$tplu=$InvItem->GetPLU();
					if($plu==$tplu){
						$tqty=$ii->GetQty() + $InvItem->GetQty();
						$ii->SetQty($tqty);
						$this->items[$num] = $ii;
						$found=1;
						break;
					}
				}
			}
			if($found==0){
				$this->num_items++;
				array_push($this->items, $InvItem);
			}
		}

	}

	function delete($num) 
	{
		if(isset($num)) {
			unset($this->items[$num]);
			$this->num_item--;
		}
	}

	function NumItems() { return $this->num_items; }
	function CurrItem() { return $this->curritem; }
	function GetSupplier() { return $this->supplierID; }
	function SetSupplier($s) { $this->supplierID=$s; }

	function listAllSupplierProducts()
	{
		$result=db_query("SELECT ID FROM invpricequantity WHERE supplierID='$this->supplierID'");
		if(db_num_rows($result)==0){
			return 1;
		}
		$row = $result->FetchRow();
		$bqid=$row["ID"];
		db_free_result($result); 

		$result=db_query("SELECT ID from inventory WHERE buyquantitypriceid='$bqid'");
		if(db_num_rows($result)==0){
			return 2;
		}

		echo "<table border=\"0\" cellpadding=\"2\" width=\"100%\" bgcolor=\"#FFFFFF\">\n";
		echo "<tr><td colspan=\"5\" align=\"left\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">Items by Supplier</font></td></tr>";
		echo "<tr><td><b>PLU</b></td><td><b>Name</b></td><td><b>Price</b></td><td><b>Qty</b></td><td></td></tr>\n";

		while($row = $result->FetchRow())){
			$iid=$row["ID"];
			$presult=db_query("SELECT PLU, name from product WHERE invID='$iid'");
			if(db_num_rows($presult)==0){
			}
			else{
				echo "<td>'$row[PLU]'</td>\n";
				echo "<td>'$row[name]'</td>\n";
				echo "<td>$price</td>\n";
				echo "<td><input type=\"text\" name=\"Qty\" size=\"8\" maxlength=\"8\" value=\"$qty\"></td>\n";

				db_free_result($presult); 
			}
			echo "</tr>\n";
		}
		echo "</table>\n";
	}

	function fillpitems($pid)
	{
		if(count($this->items)!=0){
			foreach($this->items as $num=>$ii){
				$iid=$ii->GetInvId();
				$qty=$ii->GetQty();
				db_query("INSERT INTO purchaseorderitems VALUES ('','$pid','$qty','$iid')");
			}
		}
		else{
			return 1;
		}
	}

	function buildItemList($title)
	{
		$count=0;
		$gtotal=0.00;
		$numi=$this->num_items;
		
		echo "<table border=\"0\" cellpadding=\"2\" width=\"100%\" bgcolor=\"#FFFFFF\">\n";
		echo "<tr><td colspan=\"6\" align=\"left\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">$title - $numi Items</font></td></tr>";
		echo "<tr><td><b>PLU</b></td><td><b>Qty</b></td><td><b>Name</b></td><td><b>Price</b></td><td><b>Sub</b></td><td></td></tr>\n";
		if(count($this->items)!=0){
			foreach($this->items as $num=>$ii){
				$count++;

				$plu=$ii->GetPLU();
				$qty=$ii->GetQty();
				$name=$ii->GetName();
				$price=$ii->GetPrice();
				$total=$ii->Total();
				$gtotal+=$total;

				if(($count%2)==0){
					echo "<tr bgcolor=\"#CCCCCC\">\n";
				}
				else{
					echo "<tr bgcolor=\"FFFFFF\">\n";
				}
				if($this->curr_item==$count){
					echo "<td><input type=\"text\" name=\"PLU\" size=\"16\" maxlength=\"13\" value=\"$plu\"></td>\n";
					echo "<td><input type=\"text\" name=\"Qty\" size=\"8\" maxlength=\"8\" value=\"$qty\"></td>\n";
					echo "<td><input type=\"text\" name=\"Name\" size=\"32\" maxlength=\"32\" value=\"$name\"></td>\n";
					echo "<td><input type=\"text\" name=\"Price\" size=\"8\" maxlength=\"12\" value=\"$price\"></td>\n";
					echo "<td><input type=\"text\" name=\"Sub\" size=\"10\" maxlength=\"12\" value=\"$total\"></td>\n";
					echo "<td><input type=\"hidden\" name=\"action\" value=\"itemedit\">\n";
					echo "<input type=\"hidden\" name=\"itemid\" value=\"$num\">\n";
					echo "<a href=\"purchase.php?action=itemedit&itemid=$num\">commit</a>\n</td>\n";
				}
				else{
					echo "<td>$plu</td>\n";
					echo "<td>$qty</td>\n";
					echo "<td>$name</td>\n";
					echo "<td>$price</td>\n";
					echo "<td>$total</td>\n";
					echo "<td><a href=\"purchase.php?action=itemeditsel&itemid=$num\">edit</a>&nbsp;\n";
					echo "<a href=\"purchase.php?action=itemdelete&itemid=$num\">delete</a>&nbsp;</td>\n";
				}
				echo "</tr>\n";
			}
		}
		if($this->curr_item==0){	// no current item so add field
			echo "<tr bgcolor=\"FFFFFF\">\n";
			//echo "<form name=\"purch\" method=\"post\" action=\"$_SERVER['PHP_SELF']\">\n";
			echo "<td><input type=\"text\" name=\"PLU\" size=\"16\" maxlength=\"13\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Qty\" size=\"8\" maxlength=\"8\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Name\" size=\"32\" maxlength=\"32\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Price\" size=\"8\" maxlength=\"12\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Sub\" size=\"10\" maxlength=\"12\" value=\"\"></td>\n";
			echo "<td><input type=\"hidden\" name=\"action\" value=\"itemadd\"></td>\n";
			echo "<td><input type=\"submit\" value=\"Add\">\n</td>\n";
			echo "</tr>\n";
		}
		echo "<tr><td colspan=\"4\" align=\"right\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">Total</td>\n";
		echo "<td>$gtotal</font></td><td>&nbsp;</td></tr>\n";
		echo "</table>\n";
	}
   
   function buildCheckInList($title, $poid)
	{
      $result=db_query("SELECT * from purchaseorderitems WHERE PurchaseOrderID='$poid'");
      if(db_num_rows($result)==0){
         print "<br><br><center>No purchase order items found...</center>";
      }
      else{
      	echo "<br><br>";
      	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
   	   echo "<tr><td colspan=\"5\"><h2>Purchase Order Items for Order: $poid</h2></td></tr>\n";
      	echo "<tr><td><h3>PLU</h3></td><td><h3>Name</h3></td><td><h3>Qty</h3></td><td><h3>Status</h3></td></tr>\n";
	   	while($row = $result->FetchRow()){
		   	$qty=$row["Quantity"];
			   $invID=$row["InventoryID"];

      		$sresult=db_query("SELECT StockLocation FROM inventory WHERE ID='$invID'");
            $srow = $sresult->FetchRow();
            $sl=$srow["StockLocation"];

   			$sresult=db_query("SELECT PLU,name FROM product WHERE invID='$invID'");
	   		$srow = $result->FetchRow();
            $plu=$srow["PLU"];
			   $name=$srow["name"];
            
            // push back inv items with status=unknown
            $ni = new InvItem();
	         $ni->SetInvID($invID);
            $ni->SetQty($qty);
            $ni->SetStatus('unknown');
            $this->Add($ni);
            
	   		echo "<tr><td>$plu</td><td>$name</td><td>$qty</td><td>\n";
            $this->statuscombo('add', 'unknown',$invID);
            echo "</td></tr>\n";
		   }
   		echo "<tr><td align=\"center\" colspan=\"5\"><input type=\"submit\" value=\"Check Items In\"></td></tr>\n";
	   	echo "</table>\n";
	   }
   }
   
   function statuscombo($a,$tid,$id)
   {
      $typelist = array('unknown','ok','missing','damaged','wrongitem','underqty','overqty');
   
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"status:$id\" width=\"250\">\n";
	      foreach ($typelist as $typeid) {
	         print "<option ";
   	      if($tid == $typeid)
	            print "selected ";
   	      print "value='$typeid'>$typeid</option>\n";
	      }
	      echo "</select>\n";
      }
      else{
         echo $type;
      }
   }
   
   function checkItemsIn($frm)
	{
      db_query("INSERT INTO transaction VALUES()");
      $tid=db_insert_id();
      
      db_query("UPDATE purchaseorder SET transactionID='$tid' WHERE purchaseorderID='$pid'");
      
      foreach($items as $iitem){
         $invid=$iitem->GetInvID();
         if($frm["status.$invid"]=='ok'){
            // credit stock, update purchaseorderitems, remove from array
            
            $result=db_query("INSERT INTO transactionitems VALUES('', '$tid', NOW(),
            '$userID','$misip','ITEMTYPE_PURCHASE','$plu','$qty')");
         }
         else{
            // create discrepancy report for status!=ok,
         }
      }
   }
}

class ProductItems
{
	var $num_items;
	var $customerID;
	var $items;	
	var $curr_item;
	var $total;

	function ProductItems()
	{
		$this->init();
	}

	function init() 
	{
		$this->num_items = 0;
		$this->customerID = 0;
		$this->items = array();
		$this->curr_item = 0;
		$this->total = 0.00;
	}

	function cleanup() 
	{
		foreach($this->items as $i) {
			unset($this->items[$i]);

		}
	}

	function Add($InvItem) 
	{
		$num_items++;
		
		if(isset($InvItem)){
			array_push($this->items, $InvItem);
		}
	}

	function delete($num) 
	{
		if(isset($num)) {
			unset($this->items[$num]);
			$this->num_item--;
		}
	}

	function NumItems() { return $this->num_items; }
	function CurrItem() { return $this->curritem; }
	function GetCustomer() { return $this->customerID; }
	function SetCustomer($s) { $this->customerID=$s; }

	function listAllSupplierProducts()
	{
		$result=db_query("SELECT ID, buyquantitypriceid from inventory WHERE supplierID='$this->supplierID'");
		while($row = $result->FetchRow()){
			$invID=$row["ID"];
			$bqid=$row["buyquantitypriceid"];
			$presult=db_query("SELECT PLU, name from product WHERE InvID='$invID'");
			$prow = $presult->FetchRow();

			$bqresult=db_query("SELECT Price, SupplierID FROM invpricequantity WHERE supplierID = '$this->supplierID'");
			$bqrow = $bqresult->FetchRow();
			$price=$row["Price"];
		}
	}

	function buildItemList()
	{
		$count=0;
		$gtotal=0.00;
		$numi=$this->num_items+1;
		
		echo "<table border=\"0\" cellpadding=\"2\" width=\"100%\" bgcolor=\"#FFFFFF\">\n";
		echo "<tr><td colspan=\"6\" align=\"left\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">Purchase Order - $numi Items</font></td></tr>";
		echo "<tr><td><b>PLU</b></td><td><b>Qty</b></td><td><b>Name</b></td><td><b>Price</b></td><td><b>Sub</b></td><td></td></tr>\n";
		if(count($this->items)!=0){
			foreach($this->items as $num=>$ii){
				$count++;

				$plu=$ii->GetPLU();
				$qty=$ii->GetQty();
				$name=$ii->GetName();
				$price=$ii->GetPrice();
				$total=$ii->Total();
				$gtotal+=$total;

				if(($count%2)==0){
					echo "<tr bgcolor=\"#CCCCCC\">\n";
				}
				else{
					echo "<tr bgcolor=\"FFFFFF\">\n";
				}
				if($this->curr_item==$count){
					echo "<td><input type=\"text\" name=\"PLU\" size=\"16\" maxlength=\"13\" value=\"$plu\"></td>\n";
					echo "<td><input type=\"text\" name=\"Qty\" size=\"8\" maxlength=\"8\" value=\"$qty\"></td>\n";
					echo "<td><input type=\"text\" name=\"Name\" size=\"32\" maxlength=\"32\" value=\"$name\"></td>\n";
					echo "<td><input type=\"text\" name=\"Price\" size=\"8\" maxlength=\"12\" value=\"$price\"></td>\n";
					echo "<td><input type=\"text\" name=\"Sub\" size=\"10\" maxlength=\"12\" value=\"$total\"></td>\n";
					echo "<td><input type=\"hidden\" name=\"action\" value=\"itemedit\"></td>\n";
					echo "<td><input type=\"hidden\" name=\"itemid\" value=\"$num\"></td>\n";
					echo "<td><a href=\"purchase.php?action=itemedit&itemid=$num\">commit</a>\n</td>\n";
				}
				else{
					echo "<td>$plu</td>\n";
					echo "<td>$qty</td>\n";
					echo "<td>$name</td>\n";
					echo "<td>$price</td>\n";
					echo "<td>$total</td>\n";
					echo "<td><a href=\"purchase.php?action=itemeditsel&itemid=$num\">edit</a>&nbsp;\n";
					echo "<a href=\"purchase.php?action=itemdelete&itemid=$num\">delete</a>&nbsp;</td>\n";
				}
				echo "</tr>\n";
			}
		}
		if($this->curr_item==0){	// no current item so add field
			echo "<tr bgcolor=\"FFFFFF\">\n";
			//echo "<form name=\"purch\" method=\"post\" action=\"$_SERVER['PHP_SELF']\">\n";
			echo "<td><input type=\"text\" name=\"PLU\" size=\"16\" maxlength=\"13\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Qty\" size=\"8\" maxlength=\"8\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Name\" size=\"32\" maxlength=\"32\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Price\" size=\"8\" maxlength=\"12\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Sub\" size=\"10\" maxlength=\"12\" value=\"\"></td>\n";
			echo "<td><input type=\"hidden\" name=\"action\" value=\"itemadd\"></td>\n";
			echo "<td><input type=\"submit\" value=\"Add\">\n</td>\n";
			echo "</tr>\n";
		}
		echo "<tr><td colspan=\"4\" align=\"right\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">Total</td>\n";
		echo "<td>$gtotal</font></td><td>&nbsp;</td></tr>\n";
		echo "</table>\n";
	}
}

?>
