<?php
require_once("timedate.php");
/*
if(!class_exists('Hashed_Cache_Lite')){
   require_once('Cache_Lite/Hashed_Cache_Lite.php');
}
*/
/**
 * Mis User.
 *
 * @package	MIS
 * @access	public
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	Al Kingsley  2004
 *
 * All rights reserved.
 */
 
class MISUser
{
   /** var boolean */
   var $logged_in;
   var $fname;
   var $lname;
   var $userID;
   var $employeeID;
   var $stationID;
   var $logintypesID;
   var $started;
   var $interfaces;
   
   var $_caching = FALSE;
   var $_force_cache_expire = TRUE; 
   var $_cache_dir = '/tmp/bhmis_cache'; // NO trailing slash
   var $_cache_expire_time=600; //600 == Ten Minutes	
   
   /**
    * Default constructor.
    *
    * @access public
    */
   function MISUser() 
   {
      $this->logged_in=false;
      $this->fname="";
      $this->lname="";
      $this->userID=0;
      $this->employeeID=0;
      $this->stationID='';
      $this->siteID=0;
      $this->logintypesID=0;
      
      /*
		 * Cache options. We default to the highest performance. If you run in to cache corruption problems,
		 * Change all the 'false' to 'true', this will slow things down slightly however.
		 */
		$cache_options = array(
			'caching' => $this->_caching,
			'cacheDir' => $this->_cache_dir.'/',
			'lifeTime' => $this->_cache_expire_time,
			'fileLocking' => true,
			'writeControl' => false,
			'readControl' => false,
		);
		//$this->Cache_Lite = new Hashed_Cache_Lite($cache_options);
   }

  /**
   * Set a user entry based upon the user id.
   *
   * @param	integer	$uid
   * @return	boolean true if successful.
   * @access	public
   */
   function SetUser($uid) 
   {
      $this->started=new TimeDate();
      $result=db_query(login_qry1) or die('Unable to query session start time.'); 
		$ts = $result->FetchRow();
      $this->started->parse($ts[0]);
      $result->Close();
      
      $q = sprintf(misuserlib_qry1, $uid);
      $result=db_query($q) or die('bum user query.'); 
      $u = $result->FetchRow();
      if(!$u){
         return 1;
      }
      $this->userID=$uid;
      $this->employeeID=$u['employeeid'];
      $this->logintypesID=$u['logintypesid'];
      $result->Close();
      
      $q = sprintf(misuserlib_qry6, $this->employeeID);
      $result=db_query($q) or die('bum employee query.'); 
      $n = $result->FetchRow();
      if(!$n){
         return 2;
      }
      $this->fname=$n['fname'];
      $this->lname=$n['lname'];
      $result->Close();
      
      if(getenv('HTTP_CLIENT_IP')){   
         $this->stationID = getenv('HTTP_CLIENT_IP');
      }
      else{   
         $this->stationID = getenv('REMOTE_ADDR');
      }
      
      $q=sprintf(misuser_qry8,$this->userID);
      $result=db_query($q);
      if(!$result){
         return 3;
      }
      else{
         $this->interfaces = array();
         while($row = $result->FetchRow()){
         $id=$row[0];
         if($id > 255){
               $x=array('name'=>$row[1],
               'login'=>$row[5],
               'list'=>$row[6],
               'browse'=>$row[7],
               'clear'=>$row[8], // needs changing to add - that's a "later" all pages job
               'edit'=>$row[9],
               'delete'=>$row[10],
               'shutdown'=>$row[11]);
               $z=array($id=>$x);
               array_push($this->interfaces, $z);
            }
         }
      }
      $result->Close();
      $this->logged_in=true;
      return 0;
   }
   
   function GetUser() 
   {
      if(!isset($this->userID)) return 0;
      return $this->userID;
   }
   
   function GetEmployee() 
   {
      if(!isset($this->employeeID)) return 0;
      return $this->employeeID;
   }
   
   function GetFullStation() 
   {
      if(!isset($this->stationID)) return '000000000000';
      return $this->stationID;
   }
   
   function UserName() 
   {
      echo $this->fname . " " . $this->lname;
   }
   
   function SessionStart()
   {
      echo $this->started->displayts();
   }
   
   function hasPerm($action, $page)
   {
      $p=explode("/", $page);
      $bd=$p[1]."/".$p[2];
      $q=sprintf(misuser_qry9,$p[2],$p[3],$action);
      $result=db_query($q);
      if(!$result){
         return true;
      }
      else{
         if($row = $result->FetchRow()){
            $q=sprintf(misuser_qry10,$row[0]);
            $res=db_query($q);
            if($r = $res->FetchRow()){
               $index=$r[0];
               foreach($this->interfaces as $key=>$value){
                  if(array_key_exists($index, $value)){
                     if($value[$index][$action] == 'Y')
                        return true;
                     else
                        return false;
                  }
               }
            }
         }
      }
      // this should return false as there's no db entry
      // but as I'm too lazy to get all the db entries done, and the
      // there's no admin written yet to handle all this...
      return true;
   }
   
   function isloggedin() 
   {
      return $this->logged_in;
   }
   
   function log_out() 
   {
      unset($this->interfaces);
      $this->logged_in=false;
   }
   
   /**
    * Log the action in the employee log.
    *
    * @param	string	$type	Type of entry (e.g. login or logout)
    * @access	private
    */
   function log($type) 
   {
      if(!isset($this->employeeid))
         return;
      $q = sprintf(misuserlib_qry4, $this->employeeid, $type);
      $this->query($q);
  }


   /**
    * Write a log entry for the users login event.
    * Uses the internal log function to log this entry. 
    * Also sets internal flag to indicate the user is currently logged in.
    *
    * @access	public
    */
   function log_start() 
   {
      $this->logged_in = true;
      $this->log(7);
   }

   /**
    * Write a log entry for the users logout event.
    * Uses the internal log function.  Checks that the user is currently logged in. This gets around problems with session timeouts and with calls before the user has actually logged in.
    *
    * @access	public
    */
    function log_end() 
    {
       if($this->logged_in){
          $this->log(8);
          $this->logged_in = false;
       }
    }

    /**
     * Grab the time of last login from the employee log.
     * This is called prior to the new login entry so that there is no need
     * to compensate for this.
     *
     * @return	boolean	true if a previous login entry was found
     */
    function get_last_login() {
       if(!isset($this->employeeid))
           return false;
       $q=sprintf(misuderlib_qry5, $this->employeeID, BHSQL_P_USERLOGIN);
       if(!$this->query($q)){
           return false;
       }
       if(!$this->load_values()){
          return false;
       }
       return true;
    }

  /**
   * Format the last login into printable format.
   *
   * @return	string	Formatted date/time.
   * @access	public
   */
  function format_last_login() {
    if (! isset($this->last_login) || $this->last_login == "")
      return "Unknown";
    $timestamp = new TimeDate();
    $timestamp->parse($this->last_login);
    $datestring = date('h:i A D F j Y', $timestamp->timestamp());
    unset($timestamp);
    return $datestring;
  }

  /**
   * Return the users id.
   *
   * @return	mixed	users id if set or false otherwise.
   * @access	public
   */
   function get_uid() 
   {
      if (isset($this->id))
         return $this->id;
      else
         return false;
   }

   function get_cache($cache_id) 
   {
      if(is_string($this->Cache_Lite->get($cache_id))){
         return unserialize($this->Cache_Lite->get($cache_id) );
      }
      return false;
   }

   function put_cache($data, $cache_id) 
   {
      return $this->Cache_Lite->save(serialize($data), $cache_id);
	}
}

?>
