<?php
/*
 * A pager thingy.
 *
 * @version	0.9.6
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2004 Al Kingsley
 * @package	MIS
 * @access	public
 *
 * Notes to bear in mind: all numbers count from zero
 * This is compensated in reporting numbers by adding 1.
 *
 */

class Page {
   var $offset;
   var $num;
   var $pagesize;
   var $numquery;
   var $prevaction;

   function Page() 
   {
      $this->offset=0;  // indexed from 1
      $this->num=0;     // from count(*)
      $this->pagesize=20;
      $this->numquery="";
   }
   
   function CheckNum($q)
   {
      if(strcmp($q, $this->numquery)==0){
         return 0;
      }
      else{
         $this->numquery=$q;
         $this->offset=0;
         $this->num=0;
         return 1;
      }
   }
   
   function SetPageSize($s)
   {
      $this->pagesize=$s;
   }
   
   function setnum($n)
   {
      $this->num=$n;
      if($this->offset > $this->num) $this->offset=$this->num;
   }
   
   function deletion($n)
   {
      $this->num=$n;
      $this->offset--;
      if($this->offset < 0) $this->offset=0;
      return $this->offset;
   }
   
   function addition($n)
   {
      $this->num=$n;
      $this->offset++;
      if($this->offset > $this->num) $this->offset=$this->num;
      return $this->offset;
   }
   
	function setcurrent($o)
   {
      $this->offset=$o;
      if($this->offset > $this->num) $this->offset=$this->num;
      if($this->offset < 0) $this->offset=0;
   }
   // this number is an offset... not an index
	function current()
	{
		return $this->offset;
	}
   
	function num()
	{
		return $this->num;
	}
   function start()
   {
      $this->offset=0;
   }
   function end($a)
   {
      if($a)
         $this->offset=$this->num-1;
      else
         $this->offset=$this->num-$this->pagesize;
   }
   function next()
   {
      $this->offset++;
      if($this->offset > $this->num-1){
         $this->offset=$this->num-1;
      }
   }
   function prev()
   {
      $this->offset--;
      if($this->offset < 0){
         $this->offset=0;
      }
   }
   function pgnext()
   {
	   if($this->num > $this->pagesize){
         $this->offset+=$this->pagesize;
   		if($this->offset > $this->num){
	      	$diff=$this->num % $this->pagesize;
		   	$this->offset=$this->num-$diff;	
		   }
	   }
      else{
         $this->offset=$this->num-1;
      }
   }
   function pgprev()
   {
      if($this->num > $this->pagesize){
         $this->offset-=$this->pagesize;
		   if($this->offset < 0){
			   $this->offset=0;
		   }
      }
       else{
         $this->offset=0;
      }
   }
   function recordof()
   {
      $ro=$this->offset+1;
      $rn=$this->num;
      echo "Record $ro of $rn";
   }
   function pageof()
   {
      $nump=(int) (floor((double) $this->num / (double) $this->pagesize))+1;
      $x=(int) floor((double) ($this->offset / (double) $this->pagesize))+1;
      echo "Page $x of $nump";
   }
   function navbutton($n)
   {
      switch($n){
      case 'home':
   	   break;
      case 'pageprev':
	      break;
      case 'prev':
	      break;
      case 'next':
   	   break;
      case 'pagenext':
	      break;
      case 'end':
         break;
      }
   }
   function query($q)
   {
      $n=$this->offset;
      if($n < 0) $n=0;
      if($this->num < $this->pagesize) $n=0;
      else{ // round offset to page size
         $n=$this->pagesize*((int)($this->offset / $this->pagesize));	
      }
      $q=$q." LIMIT $this->pagesize OFFSET $n";
      
      return $q;
   }
   function setprev($action) {
      $this->prevaction = $action;
   }
   function getprev() {
      return $this->prevaction;
   }
}

?>
