<?php
/*
 * A generic transaction.
 *
 * @version	0.9.7
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2004 Al Kingsley
 * @package	MIS
 * @access	public
 */

require_once($_SESSION['CFG']->libdir."/timedate.php");

class TransItem
{
   var $id;
   var $transactionid;
   var $enteredat;
   var $enteredby;
   var $enteredstation;
   var $type;
   var $plu;
   var $quantity;
	

	function TransItem()
	{
		$this->id=0;
      $this->transactionid=0;
      $this->enteredat='';
      $this->enteredby=0;
      $this->enteredstation='';
      $this->type=0;
      $this->plu='';
      $this->quantity=0;
	}

	function Fill($id)
	{
		$qry=sprintf(transaction_qry9, $id);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->id=$row['id'];
         $this->transactionid=$row['transactionid'];
         $this->enteredat=$row['enteredat'];
         $this->enteredby=$row['enteredby'];
         $this->enteredstation=$row['enteredstation'];
         $this->type=$row['type'];
         $this->plu=$row['plu'];
         $this->quantity=$row['quantity'];
         
         return true;
      }
      return false;
	}
}

class PayItem
{
   var $id;
   var $payid;
   var $tranid;
   var $paytype;
   var $amount;
   var $enteredat;
   var $enteredby;
   var $enteredstation;
   var $paymentdetailsid;

	function TransItem()
	{
		$this->id=0;
      $this->payid=0;
      $this->transid=0;
      $this->paytype=0;
      $this->amount=0.0;
      $this->enteredat='';
      $this->enteredby=0;
      $this->enteredstation='';
      $this->paymentdetailsid=0;
	}
   
   function Fill($id)
   {
      $qry=sprintf(transaction_qry7, $id);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->id=$row['id'];
         $this->payid=$row['payid'];
         $this->transid=$row['transid'];
         $this->paytype=$row['paytype'];
         $this->amount=$row['amount'];
         $this->enteredat=$row['enteredat'];
         $this->enteredby=$row['enteredby'];
         $this->enteredstation=$row['enteredstation'];
         $this->paymentdetailsid=$row['paymentdetailsid'];
         
         return true;
      }
      return false;
   }
   
   function GetAmount()
   {
      return $this->amount;
   }
}

class Transaction
{
   var $id;
   var $transactionid;
   var $enteredat;
   var $enteredby;
   var $enteredstation;
   var $statusid;
   var $paymenttypeid;
   var $refnum;
   var $description;
   var $open;
   var $reconciled;
   var $taxable;
   var $settlementid;
   var $linkid;
   
   var $transitems;
   var $payitems;

   /**
   * Constructor.
   * @access	public
   */
	function Transaction()
	{
		$this->id=0;
		$this->transactionid=0;
		$this->enteredat="";
		$this->enteredby="";
		$this->enteredstation="";
		$this->statusid=0;
		$this->paymenttypeid=0;
		$this->refnum="";
		$this->description="";
		$this->open='N';
		$this->reconciled='N';
		$this->taxable='Y';
		$this->settlementid=0;
		$this->linkid=0;
      
      $this->transitems=array();
      $this->payitems=array();
	}
   
   function GetID() { return $this->ID; }
   
   function Fill($id, $bOffset=true)
   {
      if($bOffset){
         $qry=sprintf(transaction_qry2, $id);
      }
      else{
         $qry=sprintf(transaction_qry3, $id);
      }
      $result=db_query($qry);
      
      if($row = $result->fetchrow()){
   	   $this->id = $id;
   	   $this->transactionid = $row["transactionid"];
      	$this->enteredat = $row["enteredat"];
	      $this->enteredby = $row["enteredby"];
      	$this->enteredstation = $row["enteredstation"];
	      $this->statusid=$row["statusid"];
   	   $this->paymenttypeid=$row["paymenttypeid"];
   	   $this->refnum=$row["refnum"];
      	$this->description=$row["description"];
   	   $this->open = $row["open"];
         $this->reconciled = $row["reconciled"];
         $this->taxable = $row["taxable"];
         $this->settlementid = $row["settlementid"];
         $this->linkid = $row["linkid"];
         
         $qry=sprintf(transaction_qry10, $this->transactionid);
         $result=db_query($qry);
         while($row = $result->FetchRow()){
            $ti=new TransItem;
            $ti->Fill($row[0]);
            array_push($this->transitems, $ti);
         }
         
         $qry=sprintf(transaction_qry8, $this->transactionid);
         $result=db_query($qry);
         while($row = $result->FetchRow()){
            $pi=new PayItem;
            $pi->Fill($row[0]);
            array_push($this->payitems, $pi);
         }
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l)
   {
		$this->enteredat=$a;
		$this->enteredby=$b;
		$this->enteredstation=$c;
		$this->statusid=$d;
		$this->paymenttypeid=$e;
		$this->refnum=$f;
		$this->description=$g;
		$this->open=$h;
		$this->reconciled=$i;
		$this->taxable=$j;
		$this->settlementid=$k;
		$this->linkid=$l;
   }
   
   function SetFromForm($frm)
   {
      $this->transactionid=$frm['transactionid'];
		$this->enteredat=$frm['enteredat'];
		$this->enteredby=$frm['enteredby'];
   	$this->enteredstation=$frm['enteredstation'];
	   $this->statusid=$frm['statusid'];
		$this->paymenttypeid=$frm['paymenttypeid'];
      $this->refnum=$frm['refnum'];
		$this->description=$frm['description'];
   	$this->open=$frm['open'];
	   $this->reconciled=$frm['reconciled'];
		$this->taxable=$frm[''];
		$this->settlementid=$frm['taxable'];
		$this->linkid=$frm['linkid'];
   }
   
   function Add()
   {
      $qry=sprintf(transaction_qry14, 
		   $this->enteredat,
		   $this->enteredby,
   		$this->enteredstation,
	   	$this->statusid,
		   $this->paymenttypeid,
      	$this->refnum,
		   $this->description,
   		$this->open,
	   	$this->reconciled,
		   $this->taxable,
		   $this->settlementid,
		   $this->linkid);
      
      db_query($qry);
      
      $result=db_query(misc_qry1);
      if($row = $result->FetchRow()){
   	   $this->ID = $this->transactionid = $row[0];
         $qry=sprintf(transaction_qry13, $this->id, $this->id);
         db_query($qry);
      }
      return $this->ID;
   }
   
   function Commit($id)
   {
      $qry=sprintf(translib_qry4, 
         $this->transactionid,
		   $this->enteredat,
		   $this->enteredby,
   		$this->enteredstation,
	   	$this->statusid,
		   $this->paymenttypeid,
      	$this->refnum,
		   $this->description,
   		$this->open,
	   	$this->reconciled,
		   $this->taxable,
		   $this->settlementid,
		   $this->linkid,
         $id);
         
      db_query($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(translib_qry5, $id);
      
      db_query($qry);
   }
   
   function Combo($a, $id, $cname)
   {
   }
   
   function NumTransItems()
   {
      return count($this->transitems);
   }
   
   function NumPayItems()
   {
      return count($this->payitems);
   }
   
   function Total()
   {
      $total=0.0;
      if(count($this->payitems)!=0){
         foreach($this->payitems as $i){
			   $total+=$i->GetAmount();
		   }
      }
      return $total;
   }
   
   function UserCombo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
		   $result=db_query(transaction_qry6);
   		echo "<select name=\"$cname\" width=\"250\">\n";
      	while($myrow = $result->FetchRow()){
   			$boo=$myrow["id"];
	   		$poo=$myrow["fname"]. " " . $myrow["lname"];
   			if($id==$boo){
	   			print "<option selected value=\"$boo\"> $boo - $poo </option>\n";
		   	}
			   else{
				   print "<option value=\"$boo\"> $boo - $poo </option>\n";
   			}
	   	}
		   print "</select>\n";
   	}
	   else{
         $qry=sprintf(transaction_qry5, $id);
		   $result=db_query($qry);
   		if($myrow = $result->FetchRow()){
		   	echo $myrow["fname"]. " " . $myrow["lname"];
		   }
   		else{
	   		echo "Not Set";
		   }
	   }
   }
   
   function StationCombo($a, $id, $cname)
   {
   }
   
   function Table($a, $id, $title, $bOffset=true, $bInside=false)
   {
      if($this->id==0){
         $this->Fill($id, $bOffset);
      }
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"address\">\n";
         echo "<tr>\n";
	      echo "<th colspan=\"2\">$title</th>\n";
      }

	   echo "<tr>\n";
      echo "<td class=\"label\">Transaction ID</td>\n";
      echo "<td>";
	   entry($a, "transactionid", 16, 16, $this->transactionid);
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"label\">When</td>\n";
      echo "<td>";
      $td=new TimeDate();
      if($a=="commit" || $a=="add"){
		   $result=db_query(login_qry1);
   		if($row = $result->FetchRow()){
            $td->parse($row[0]);
         }
      }
      else{
         $td->parse($this->enteredat);
      }
      $td->tscontrol($a, "enteredat");
      echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"label\">Who</td>\n";
      echo "<td>";
	   FillEmployeeName($a, "enteredby", $this->enteredby);
   	echo"</td>\n";
	   echo "</tr>\n";

      echo "<tr>\n";
      echo "<td class=\"label\">Where</td>\n";
      echo "<td>";
	   fillEnteredStation($a, $this->enteredstation);
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"label\">Status</td>\n";
      echo "<td>";
	   fillStatusCombo($a, "statusid", $this->statusid);
   	echo"</td>\n";
	   echo "</tr>\n";
      /*
      echo "<tr>\n";
      echo "<td width=\"20%\" align=\"right\">Payment</td>\n";
      echo "<td>";
      //fillPayTypeCombo
	   entry($a, "PaymentTypeID", 16, 16, $this->PaymentTypeID);
   	echo"</td>\n";
	   echo "</tr>\n";
      */
      echo "<tr>\n";
      echo "<td class=\"label\">Reference Number</td>\n";
      echo "<td>";
	   entry($a, "refnum", 32, 32, $this->refnum);
   	echo"</td>\n";
	   echo "</tr>\n";

      echo "<tr>\n";
      echo "<td class=\"label\">Description</td>\n";
      echo "<td>";
	   entry($a, "description", 64, 64, $this->description);
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"label\">Open</td>\n";
      echo "<td>";
      CheckBox($a, "open", $this->open, "open");
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"label\">Reconciled</td>\n";
      echo "<td>";
      CheckBox($a, "reconciled", $this->reconciled, "reconciled");
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"label\">Taxable</td>\n";
      echo "<td>";
      CheckBox($a, "taxable", $this->taxable, "taxable");
   	echo"</td>\n";
	   echo "</tr>\n";
      /*
		   $this->settlementID,
		   $this->linkID
      */   
      echo "<tr>\n";
      echo "<td class=\"label\">Number Items</td>\n";
      echo "<td>";
	   echo $this->NumTransItems();
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"label\">Number Pay Items</td>\n";
      echo "<td>";
      echo $this->NumPayItems();
      echo "</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"label\">Total</td>\n";
      echo "<td>";
	   echo $this->Total();
   	echo"</td>\n";
	   echo "</tr>\n";
      
      if(!$bInside){
   	   echo "</table>\n";
      }
   }
   
   function Find($bOutput)
   {
   }
}

?>
