<?php
/*
product.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/reporter.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], reports_prod_pagetitle)!=0){
   $_SESSION['title']=reports_prod_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

if(!isset($prodrep)){
   $prodrep=& new ProductReporter();
}

switch($_REQUEST['action']){
   case "new" :
      clearform();
      break;
      
	case "query" :
		productquery($_POST);
		break;
      
   case "newturnover" :
		clearturnover();
		break;
      
   case "queryturnover" :
		productturnover($_POST);
		break;
  
   case "newbestworse" :
      bwquery();
      break;
      
   case "bestworse" :
		productbw($_POST);
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function clearForm()
{
   $frm["plu"]="";
   $frm["reporttype"] = "incremental";
   $frm["newaction"] = "query";
   include("templates/prodreport.php");
}

function productquery($frm)
{
   global $prodrep;
   
   $prodrep->SetAll($frm["period"],$frm["num_periods"], $frm["period"], 'nperiods');
   $prodrep->SetPLU($frm["plu"]);
   
   include("templates/prodreport.php");
   $prodrep->QueryByProduct();
   //$prodrep->PlotByProduct("Products", "", "");
}

function clearturnover()
{
   global $prodrep;
   $frm["PLU"]="";
   $frm["newaction"] = "queryturnover";
   include("templates/prodreport_to.php");
}

function productturnover($frm)
{
   global $prodrep;
   $prodrep->SetPLU($frm["plu"]);
   $prodrep->SetStartDate($frm["startdateday"],$frm["startdatemonth"],$frm["startdateyear"]);
   $prodrep->SetEndDate($frm["enddateday"],$frm["enddatemonth"],$frm["enddateyear"]);
   include("templates/prodreport_to.php");
   $prodrep->QueryByTurnover();
   
   // algos go thus:
   // 1.0 is ideal, < 1.0 is under ordering,  > 1.0 over ordering
}

function DrawControl()
{
   global $prodrep;
   $prodrep->DrawControl();
}

function DrawStartdate($a, $n)
{
   global $prodrep;
   $prodrep->DrawStartControl($a, $n);
}

function DrawEnddate($a, $n)
{
   global $prodrep;
   $prodrep->DrawEndControl($a, $n);
}

// fast / slow - rates of movement
function fsquery()
{
}

function productfs()
{
}

// best / worse
function bwquery()
{
   $frm["limit"]=100;
   $frm["newaction"] = "bestworse";
   include("templates/prodreport_bw.php");
}

function productbw($frm)
{
   $sdate=$frm["startdateyear"]."-".$frm["startdatemonth"]."-".$frm["startdateday"]." 00:00:01";
   $edate=$frm["enddateyear"]."-".$frm["enddatemonth"]."-".$frm["enddateday"]." 23:59:59";
   $limit=$frm['limit'];
   
   $qry=sprintf(reportprod_qry1, $sdate, $edate, $limit);
   $result=db_query($qry);
      
   echo "<table cellpadding=\"2\" cellspacing=\"2\" width=\"80%\">\n";
   echo "<tr><td colspan=\"4\" align=\"center\"><h2>Rank By Product</h2></td>\n";
   echo "<tr><td colspan=\"2\" align=\"center\"><h3>In Period</h3></td>\n";
   echo "<td colspan=\"2\" align=\"center\">$sdate - $edate</td></tr>\n";
   echo "<tr><td><h3>Rank</h3></td><td><h3>Barcode</h3></td><td align=\"right\"><h3>Quantity</h3></td><td align=\"right\"><h3>Amount</h3></td></tr>";
   $n=1;
   $c=0;
   while($row=$result->FetchRow()){
      $qry=sprintf(reportprod_qry2, $row[0]);
      $presult=db_query($qry);
      
      if($prow=$presult->FetchRow()){
         $a=sprintf("%0.2f",(($prow[0] + ($prow[0]*$prow[1]))*$row[1]));
      }
      if($c%2==0)
         echo "<tr bgcolor=\"#DDDDDD\">\n";
      else
         echo "<tr>\n";
      echo "<td>$n</td><td>$row[0]</td><td align=\"right\">$row[1]</td><td align=\"right\">$a</td>\n";
      $n++;
      $c++;
   }
   /*
   echo "<tr><td colspan=\"2\" align=\"center\"><h2>By Amount</h2></td>\n";
   echo "<td colspan=\"2\" align=\"center\">$sdate - $edate</td></tr>\n";
   
   $result=db_query("select ti.PLU, sum(ti.quantity), (sum(ti.quantity)*ci.UnitPrice) as val from 
      transactionitems as ti, paymentitem as pi, plu_cache as ci
      where ti.EnteredAt between '$sdate' AND '$edate' and ti.PLU=ci.PLU
      group by ti.PLU order by val desc limit $limit");
      
   $n=1;
   $c=0;
   while($row=$result->FetchRow()){
      if($c%2==0)
         echo "<tr bgcolor=\"#DDDDDD\">\n";
      else
         echo "<tr>\n";
      $a=sprintf("%0.2f",($row[2]));
      echo "<td>$n</td><td>$row[0]</td><td align=\"right\">$row[1]</td><td align=\"right\">$a</td>\n";
      $n++;
      $c++;
   }
   */
   echo "</table>";
}

?>
