<?php
/*
station.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/auth.php");
require_once($_SESSION['CFG']->libdir."/locale.php");
require_once($_SESSION['CFG']->libdir."/currency.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], station_pagetitle)!=0){
   $_SESSION['title']=station_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(station_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addStation();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseStation($id);
		break;

	case "edit" :
		editStation($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelStation($_REQUEST['id']);
      }
      else{
         deleteStation($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listStation($_REQUEST['id']);
      }
		break;
      
   case "cfmdelete" :
      deleteStation($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listStation();
		break;

	case "add" :
		insertStation($_POST);
		break;

	case "commit" :
		commitStation($_POST);
		listStation();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listStation();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
 function CountNum()
{
   $result=db_query(station_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"] = 0;
   $frm["name"] = "";
   $frm["mac"] = "";
   $frm["groupid"] = "";
   $frm["localeid"] = "";
   $frm["currencyid"] = "";
   $frm["active"] = "";

   return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(station_qry2, $id);
   }
   else{
      $qry=sprintf(station_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
	
	$frm["id"] = $id;
   $frm["name"] = $row["name"];
   $frm["mac"] = $row["mac"];
   $frm["groupid"] = $row["groupid"];
   $frm["localeid"] = $row["localeid"];
   $frm["currencyid"] = $row["currencyid"];
   $frm["active"] = $row["active"];

   //$if=$row["interfaceID"];
   $gid=$row["groupid"];
   $bcid = $row["currencyid"];

	if(!isset($bcid) || $bcid==0){
		$frm["currname"]="Not Set";
	}
	else{
		$result=db_query("select country, bigname from currency where id = '$bcid'");
		$row = $result->FetchRow();
		$frm["currname"]=$row["country"]. " - " . $row["bigname"];
	}
   /*
   if($if < 2){
      $frm["ifname"]="Not Set";
   }
   else{
      $result=db_query("SELECT Name FROM interface WHERE ID = '$if'");
	   $row = $result->FetchRow();
      $frm["ifname"]=$row["Name"];
   }
   */
   if($gid < 2){
      $frm["groupname"]="Not Set";
   }
   else{
      $result=db_query("select name from groups where id = '$gid'");
   	$row = $result->FetchRow();
      $frm["groupname"]=$row["name"];
   }
   
   return $frm;
}

function addStation()
{
   $frm=clearform();
	$frm["newaction"] = "add";
   $frm["heading"] = "Station Add";
		
	include("templates/stationedit.php");
}

function editStation($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Station Edit";

	include("templates/stationedit.php");
}

function browseStation($id) 
{
	$frm=fillform($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Station Browse";
	
	include("templates/stationedit.php");
}

function chkdelStation($id)
{
	$frm=fillform($id);
	$frm["newaction"] = "cfmdelete";
	include("templates/stationedit.php");
}

function deleteStation($id) 
{
   $qry=sprintf(station_qry7, $id);
	db_query($qry);
}

function insertStation($frm) 
{
   $qry=sprintf(station_qry5, $frm['name'],$frm['mac'],$frm['groupid'],$frm['localeid'],$frm['currencyid'],
      YN($frm['active']));
   db_query($qry);
}

function commitStation($frm) 
{
	$qry=sprintf(station_qry6, $frm['name'],$frm['mac'],$frm['groupid'],$frm['localeid'],$frm['currencyid'],
      YN($frm['active']), $frm['id']);
   db_query($qry);
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "currencyid");
}

function LocaleCombo($action, $id)
{
   $a=new Locale();
   $a->Combo($action, $id, "localeid");
}

function listStation()
{
	$q=$_SESSION["pageindex"]->query(station_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Station</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$n=$myrow["name"];
		print "<tr><td>$n</td>";
		print "<td>";
		$wibbler=$myrow["id"];
		print "<a href=\"station.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"station.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"station.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
