<?php
/*
measures.php

Copyright (C)2002  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/currency.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], stock_pagetitle)!=0){
   $_SESSION['title']=stock_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(invpq_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addMeasure();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseMeasure($id);
		break;

	case "edit" :
		editMeasure($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelMeasure($_REQUEST['id']);
      }
      else{
         deleteMeasure($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listMeasure();
      }
      break;  
	
   case "cfmdelete" :
      deleteBank($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listBank();
		break;

	case "add" :
		insertMeasure($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listMeasure();
		break;

	case "commit" :
		commitMeasure($_POST);
		listMeasure();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listMeasure();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(invpq_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"]="";
   $frm["invprqid"]="";
   $frm["nameid"]="";
   $frm["quantity"]="";
   $frm["quantitytypeid"]="";
   $frm["udv"]="";
   $frm["price"]="";
   $frm["basecurrencyid"]=0;
   $frm["supplierid"]="";
   $frm["suppliercode"]="";
   $frm["ediid"]=0;
   $frm["accountid"]=0;
   $frm["taxid"]=0;
   
   return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(invpq_qry2, $id);
   }
   else{
      $qry=sprintf(invpq_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
	
   $frm["id"]=$id;
   $frm["invprqid"]=$row["invprqid"];
   $frm["nameid"]=$row["nameid"];
   $frm["quantity"]=$row["quantity"];
   $frm["quantitytypeid"]=$row["quantitytypeid"];
   $frm["udv"]=$row["udv"];
   $frm["price"]=$row["price"];
   $frm["basecurrencyid"]=$row["basecurrencyid"];
   $frm["supplierid"]=$row["supplierid"];
   $frm["suppliercode"]=$row["suppliercode"];
   $frm["ediid"]=$row["ediid"];
   $frm["accountid"]=$row["accountid"];
   $frm["taxid"]=$row["taxid"];

   return $frm;
}

function addMeasure()
{
   $frm=clearform();
	$frm["newaction"] = "add";
	$frm["id"] = "Auto number";
   $frm["heading"] = "Buy Price Quantity Add";

	include("templates/measureedit.php");
}

function editMeasure($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Buy Price Quantity Edit";
	include("templates/measureedit.php");
}

function browseMeasure($id) 
{
   $frm=fillform($id, true);
   $frm["newaction"] = "browse";
	$frm["heading"] = "Buy Price Quantity Browse";
	include("templates/measureedit.php");
}

function chkdelMeasure($id)
{
   $frm=fillform($id, $false);
   $frm["newaction"] = "cfmdelete";
	$frm["heading"] = "Buy Price Quantity Delete";
   
	include("templates/measureedit.php");
}

function deleteMeasure($id) 
{
   $qry=sprintf(invpq_qry6, $id);
   db_query($qry); 
}

function insertMeasure($frm) 
{
   $qry=sprintf(invpq_qry4, $frm['invprqid'],$frm['nameid'],$frm['quantity'],$frm['quantitytypeid'],$frm['udv'],
      $frm['price'],$frm['basecurrencyid'],$frm['supplierid'],$frm['suppliercode'],$frm['ediid'],$frm['accountid'],
      $frm['taxid']);
   db_query($qry);
}

function commitMeasure($frm) 
{
   $qry=sprintf(invpq_qry5, $frm['invprqid'],$frm['nameid'],$frm['quantity'],$frm['quantitytypeid'],$frm['udv'],
      $frm['price'],$frm['basecurrencyid'],$frm['supplierid'],$frm['suppliercode'],$frm['ediid'],$frm['accountid'],
      $frm['taxid'], $frm['id']);
   db_query($qry);
}

function fillDependantInv($id)
{
   $qry=sprintf(invpq_qry8, $id);
   $result=db_query($qry);
   $ret=db_num_rows($result);
   print "<tr><td colspan=\"2\" align=\"center\"><h3>Dependant Inventory Items - $ret items</h3></td></tr>\n";
   while($r = $result->FetchRow()){
      print "<tr><td colspan=\"4\"><a href=\"inventory.php?action=browse&id=$r[0]\">$r[0] - $r[1]&nbsp</a></td></tr>\n";
   }
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "basecurrencyid");
}

function listMeasure()
{
	$q=$_SESSION["pageindex"]->query(invpq_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";
	print "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	//print "<td colspan=\"2\" align=\"right\">Price Quantity Name</td><td colspan=\"3\">";
	//fillinvPriceNameCombo("nameID", $_SESSION['invbpnameid']);
	//print "<input type=\"submit\" value=\"Go\">";
	//print "</td></tr>";
	echo "<tr><td><h3>Quantity</h3></td><td><h3>Packs Of</h3></td><td><h3>Price</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		print "<tr><td>";
		if($myrow["price"]){
			$wibbler=$myrow["id"];
			$n=$myrow["price"];
			$q=$myrow["quantity"];
			$p=$myrow["udv"];
			print "$q</td><td>$p</td><td>$n</td><td>";
			print "<a href=\"measures.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
			print "<a href=\"measures.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
			print "<a href=\"measures.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		}		
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "</form>";
	echo "<br><br>";
}

?>
