<?php
/*
supplier.php

Copyright (C)2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/account.php");
require_once($_SESSION['CFG']->libdir."/address.php");
require_once($_SESSION['CFG']->libdir."/contact.php");
require_once($_SESSION['CFG']->libdir."/chargeaccount.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], supplier_pagetitle)!=0){
   $_SESSION['title']=supplier_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(supplier_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addSupplier();
		break;

	case "browse":
      $id=updateNav($_POST);
		browseSupplier($id);
		break;

	case "edit" :
		editSupplier($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelSupplier($_REQUEST['id']);
      }
      else{
         deleteSupplier($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listSupplier();
      }
      break;  
	
   case "cfmdelete" :
      deleteSupplier($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listSupplier();
		break;

	case "add" :
		insertSupplier($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listSupplier();
		break;

	case "commit" :
		commitSupplier($_POST);
		break;

	case "list":
	default :
      updateNav($_POST);
		listSupplier();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(supplier_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = "";
   $frm["supplierid"] = "";
   $frm["intsupplierid"] = "";
   $frm["cmid"] = "";
   $frm["typeid"] = "";
   $frm["name"] = "";
   $frm["addressid"] = "";
   $frm["invoicename"] = "";
   $frm["invoicecontactid"] = "";
   $frm["contactid"] = "";
   $frm["chargeid"] = "";
   $frm["ediid"] = "";
   $frm["accountid"] = "";
   $frm["linkid"] = "";
   $frm["active"] = "";
   $frm["notes"] = "";
   
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(supplier_qry2, $id);
   }
   else{
      $qry=sprintf(supplier_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

   $frm["id"] = $id;
   $frm["supplierid"] = $row["supplierid"];
   $frm["intsupplierid"] = $row["intsupplierid"];
   $frm["cmid"] = $row["cmid"];
   $frm["typeid"] = $row["typeid"];
   $frm["name"] = $row["name"];
   $frm["addressid"] = $row["addressid"];
   $frm["invoicename"] = $row["invoicename"];
   $frm["invoicecontactid"] = $row["invoicecontactid"];
   $frm["contactid"] = $row["contactid"];
   $frm["chargeid"] = $row["chargeid"];
   $frm["ediid"] = $row["ediid"];
   $frm["accountid"] = $row["accountid"];
   $frm["linkid"] = $row["linkid"];
   $frm["active"] = $row["active"];
   $frm["notes"] = $row["notes"];
   
	return $frm;
}

function addSupplier()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	$frm["id"] = "";
   $frm["heading"] = "Supplier Add";

	include("templates/supplieredit.php");
}

function editSupplier($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Supplier Edit";

	include("templates/supplieredit.php");
}

function browseSupplier($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Supplier Browse";
	
	include("templates/supplieredit.php");
}

function chkdelSupplier($id)
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Supplier Delete";
	include("templates/supplieredit.php");
}

function deleteSupplier($id)
{
   $qry=sprintf(supplier_qry6, $id);
	db_query($qry);
}

function insertSupplier($frm) 
{
	$a=new Address();
   $a->SetFromForm($frm);
	if(!$a->Find(false)){
      $adid=$a->Add();
   }
   else{
      $adid=$a->GetID();
   }
   
   $qry=sprintf($qry=sprintf(supplier_qry4, $frm['intsupplierid'],$cmid,$frm['typeid'],$frm['name'],$adid, $frm['invoicename'],
      $frm['invoicecontactid'],$frm['contactid'],$frm['chargeid'],$frm['ediid'],$frm['accountid'],$frm['linkid'],
      $frm['active'],$frm['notes']));
   $result=db_query($qry);
   
   // update the supplier
   // add a charge account
   // add a contact
   
   /*
	// Step 2. Update Contact Info
	$frm["ContactDetailsID"]=insertContactDetails($frm);
	$cid=insertContact($frm);

	// Step 3. Update ChargeID (or not)
	$frm["standardTerms"] = yesno(isset($frm["standardTerms"]));
	$frm["CODTerms"] = yesno(isset($frm["CODTerms"]));
	$frm["prepaidTerms"] = yesno(isset($frm["prepaidTerms"]));
	$frm["termsType"] = yesno(isset($frm["termsType"]));
	$frm["dueMonthEnd"] = yesno(isset($frm["dueMonthEnd"]));
	$caid=insertChargeAcct($frm);

	
   */
}

function commitSupplier($id, $frm) 
{
	$a=new Address();
   $a->SetFromForm($frm);
	if(!$a->Find(false)){
      $adid=$a->Add();
   }
   else{
      $adid=$a->GetID();
   }

	// Step 2. Update Contact Info
	$frm["contactdetailsid"]=insertContactDetails($frm);
	$cid=insertContact($frm);

	// Step 3. Update ChargeID (Or not)
	$frm["standardterms"] = yesno(isset($frm["standardterms"]));
	$frm["codterms"] = yesno(isset($frm["codterms"]));
	$frm["prepaidterms"] = yesno(isset($frm["prepaidterms"]));
	$frm["termstype"] = yesno(isset($frm["termstype"]));
	$frm["duemonthend"] = yesno(isset($frm["duemonthend"]));
	$caid=insertChargeAcct($frm);

	// Step 4. Update Supplier
	$active = yesno(isset($frm["Active"]));
	$result=db_query("update supplier set name='$frm[name]',	active='$active', addressid='$adid',
      contactid='$cid',	chargeid='$caid' where id='$id'");
}

function CMTable($a, $id)
{
   $cm=new CreateMod();
   $cm->Fill($id);
   $cm->FillTable();
}

function ContactList()
{
   /*
   $cdi=new ContactDetails($id);
   $cdi->buildItemList($a, "supplier.php", "Contact Details");
	}
   */
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "address");
}

function ChargeTable($a, $id)
{
   $c=new ChargeAccount();
   $c->Table($a, $id, "charge");
}

function listSupplier()
{
	$q=$_SESSION["pageindex"]->query(supplier_qry7);
	$result=db_query($q);
   $_REQUEST['action']="list";

	echo "<br><br>";
   echo "<table border=\"0\" cellpadding=\"0\" width=\"100%\">\n";
	echo "<tr><td><h3>Supplier</h3></td><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$n=$myrow["name"];
      if($n=="") $n="&nbsp;";
		print "<tr><td>$n</td>";
		print "<td>";
		$wibbler=$myrow["id"];
		print "<a href=\"supplier.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"supplier.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"supplier.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
